
/*
 *
 * 5648-C83, 5648-C84 (C) COPYRIGHT International Business Machines Corp., 2007 
 * All rights reserved * Licensed Materials - Property of IBM  
 * 
 */
 

EventBroker = new function () {

	//CR181 begin
	this.eventIDTicker = -Math.pow(2, 53);	// This variable will cause problems if we overflow JS max int size (2^53) by incrementing with each sent event, but that's highly unlikely.
	this.Internal_TIP_Event_Identifier_Key = "Internal_TIP_Event_Identifier_Key";
	this.transformStringCache = {};
	this.transformsQueue = new Array();
	this.transformedEventCacheQueue = new Array();
	this.transformedEventCache = {};
	this.transformedEventCacheQueueSize = MAX_CACHESIZE_TRANSFORMEDEVENT;
	//CR181 end
    
    this.BasePiiPrefix          = "basepii";
    this.ProcessHandler         = "processEvent";
    // Task type
    this.SINGLETASK             =   0;
    this.MULTITASK              =   1;
    this.HIDDENTASK             =   2;
    this.MODALTASK              =   3;

//    this.eventsStack            =   new Array();
    this.subscribedPortletList  =   new Array(); // eventhandler of all subscribed portlets
    this.subscribedPortletTopics  =   new Array(); // topic handlers of all subscribed portlets
    this.loadPageWireToResume   =   new Array(); // a wire holder while loading page
    this.switchPageSourcePortletId = null;
    this.wiresToResume          =   new Array(); // wires to resume after open page
    this.portletEventQueue      =   new Array();
    this.pageEventQueue         =   new Array();
    this.pageWindowNumberQueue  =   new Array(); // 250636, the number of windows is set in content.jsp, and used by this.runSendEventToPage

    this.launchPageWaitPortletQueue  =   new Array(); //Qui
    this.sendEventInProgress    =   false;
    this.switchPageInProgress   =   false;
    this.loadPageWireInProgress =   false;
    this.lastOpenPage           =   null;
    this.exceptionQueue         =   null;
 //   this.currentEventStackIndex =   0;   
	
    this.topicPrefix            =   "/com/ibm/isclite/event/topic/";
    this.portletTopicPrefix     =   this.topicPrefix+"portlet/";
    this.pageTopicPrefix        =   this.topicPrefix+"page/";
	// TJE test this.NavigationHandler      =   contextRoot + "/navigation.do?";
 //   this.StackEventsLimit       =   4; // 3 chaining events + 1 source event
	
    //
    // Execute send event to portlet. This is called from 
    // war/html/isclite/Content.jsp (classic pages) and also ffcontent.js (freeform pages)
	// It is used to trigger any queued events that may have come in while the portlet/iwidget was unavailable (reloading, not yet loaded).
	// Especially important for iwidgets since they will finish loading later.
    // @param pii portlet pii
    // @param pageId page id where this portlet is
    //
    this.runSendEventToPortlet=function(pii, pageId){
		var portletObj = this.getPortletObjectByPii(pii, pageId, true);
		if( portletObj == null ) return;
		
		//251399, the below lines for 246291 doesn't work on dojo1.5, so change back to call it in iWEventingExtension.launchPageCallback
//		//246291 begin - Launching page and passing context. Sends the event array from iWidget to portlet.
//		if (portletObj.portletData.iwidget == "false" && !/*TIP_DOJO_NS*/dojo.isIE) {
//		    //247563, this reference of sendEventArrayToPortlet doesn't work on IE.
//		    //we'll call it later in iWEventingExtension.iWLaunchPageBroker.launchPageCallback
//				iWEventingExtension.sendEventArrayToPortlet(portletObj.portletData.namespace, pageId);
//		}
//		//246291 end
		
		//246529 - for iWidgets, we subscribe this to the WIDGET_LOADED loaded event, if the widget is already loaded we execute the runSendEventToIWidget() immediatly.
		if (portletObj.portletData.iwidget == "true" && !/*TIP_DOJO_NS*/dojo.isIE) { //247563
			var iWidgetContainer = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();  //247631
			var widget = iWidgetContainer.getWidgetById(iWidgetUtils.piiToWidgetId(pii)); //247619
			if (widget == null) { //248199, in case this is an isolated iwidget.
				widget = iWBridge.findIframedWidget(iWidgetUtils.piiToWidgetId(pii));
			}
			if (widget && (widget.loaded == true)) {
				//251399, the below fix for 246473 doesn't work on dojo1.5, so change back to call it in iWEventingExtension.launchPageCallback
				//iWEventingExtension.sendEventArrayToIW(pii, null, pageId); //246473, we also deliver the events sent by the broadcastEvents API.
				iWEventingExtension.runSendEventToIWidget(pii, pageId);
			} else { //248199, for iframe, we'll get the eventService from the iframed enabler
				var iwId = iWidgetUtils.piiToWidgetId(pii);
				var eventService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
				
				var frame = document.getElementById(pii + "_iframe");
				if(frame){
					var doc = frame.contentWindow || frame.contentDocument;
					if(doc && (typeof(doc.com)!='undefined') && doc.com.ibm.mashups.services.ServiceManager){
						eventService = doc.com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
					}
					eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + iwId, null, function(){doc.iWEventingExtension.runSendEventToIWidget(pii, pageId);}, null, null);
				} else {
					eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + iwId, null, function(){iWEventingExtension.runSendEventToIWidget(pii, pageId);}, null, null);
				}
			}
			return;
		} // if (portletObj.portletData.iwidget == "true" && !/*TIP_DOJO_NS*/dojo.isIE)
	
		if( this.isProcessHandlerExists( portletObj.portletData.namespace ) ) {
			var eventObj = null;
			if(this.portletEventQueue[pii]){
				eventObj = this.portletEventQueue[pii];
				this.portletEventQueue[pii] = null; //remove this pii from queue
			}else if(this.pageEventQueue[pageId]){
				this.pageEventQueue[pageId].eventSentCount++;
				eventObj = this.pageEventQueue[pageId].eventObj;
				if(this.pageEventQueue[pageId].numberOfPortlets >= this.pageEventQueue[pageId].eventSentCount){
					// all portlets are rendered...
					if(this.pageEventQueue[pageId].executeWires){
						// resume wires
						this.resumeSendEvent();
						return;
					}
					this.pageEventQueue[pageId] = null; //remove this pageId from queue
					this.pageWindowNumberQueue[pageId] = null; //250636, remove the number of windows queue
				}
				if(this.pageEventQueue[pageId] && this.pageEventQueue[pageId].executeWires){
					// dont send event to portlet on this page. Need to wait
					// for all portlets to render before resume wires
					return;
				}
				//PTE TBSM 1294 caching when ALL portlets were NOT loaded at the time of launchPageEventCallback was called
				if(EventBroker.launchPageWaitPortletQueue[pageId])
				{
					if(EventBroker.launchPageWaitPortletQueue[pii])
					{	
						EventBroker.launchPageWaitPortletQueue[pageId].waitingPortlets--;
						delete EventBroker.launchPageWaitPortletQueue[pii];
						if(EventBroker.launchPageWaitPortletQueue[pageId].waitingPortlets == 0)
						{
							delete EventBroker.pageEventQueue[pageId];
							delete EventBroker.launchPageWaitPortletQueue[pageId];
							var pageObj = EventBroker.getPageObject(pageId, null, null,true);
							if(!pageObj){
								// page still not found
								EventBroker.logMessageInServer(1021, "FrameworkEventBroker.launchPageFrameworkEventCallback");
							}else{
								EventBroker.broadcastToPage(pageId, eventObj, null);
								return;
							}
						}
					}
				}
			}else{
				// dont do anything
				return;
			}

			this.sendEventToPortlet(portletObj.portletData.namespace, eventObj);
		}
	}

    //
    // Execute send event to page. This is called from 
    // war/secure/isclite/tiles/content.jsp
    // @param pageId page id
    //
    this.runSendEventToPage=function(pageId, numberOfPortlets){
        if(this.pageEventQueue[pageId]){
            var portlets = this.getPortletsFromPage(pageId);
            var portletsLoaded = true;
            for(var i = 0; i < portlets.length; i++){
                // need to check if process handler function is defined.
                // As long as there is one defined, call resumeSendEvent
				
                if(!this.isProcessHandlerExists(portlets[i].namespace)){
				
                    portletsLoaded = false;					
					break; 
                }
            }
            if(portletsLoaded == true){
                // all portlets are loaded, called resumeSendEvent now
                this.resumeSendEvent();
		delete this.pageWindowNumberQueue[pageId];
            }else{
                // portlets not loaded, runSendEventToPortlet will handle it
                this.pageEventQueue[pageId].numberOfPortlets = numberOfPortlets;
                this.pageEventQueue[pageId].eventSentCount = 0;
            }
        }
        
        //247563, if on IE, we should wait for pageEventQueue[pageId] to be ready,
        //then start sending events.
        //if (/*TIP_DOJO_NS*/dojo.isIE) { //251467, rollback as FF and IE behave the same on TIP2.2+dojo1.5
            var iwObjs = iWidgetUtils.getIwidgetObjectsFromPage(pageId); //248252
            var pii;
            for (var i=0; i<iwObjs.length; i++) { //251617, replacing for-in loop with for loop because for-in loop fails on IE in some cases.
				if(iwObjs[i] == null || iwObjs[i].portletData == null) break; //PM79026
                pii = iwObjs[i].portletData.oid;
                var iwId = iWidgetUtils.piiToWidgetId(pii);
                var iWidgetContainer = com.ibm.mashups.iwidget.model.Factory.getGlobalWidgetModel();  //247631
                var widget = iWidgetContainer.getWidgetById(iwId);
			          if (widget && (widget.loaded == true)) {
			              iWEventingExtension.sendEventArrayToIW(pii, null, pageId);
					          iWEventingExtension.runSendEventToIWidget(pii, pageId);
			          } else {
					          var eventService = com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
					          
                    //248199, for iframe, we'll get the eventService from the iframed enabler
										var frame = document.getElementById(pii + "_iframe");
      					    if(frame){
      					        var doc = frame.contentWindow || frame.contentDocument;
      					        if(doc && doc.com && doc.com.ibm.mashups.services.ServiceManager){
      					            eventService = doc.com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME);
      					        }
     					         eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + iwId, null, function(){doc.iWEventingExtension.runSendEventToIWidget(pii, pageId);}, null, null);
     					     } else {
      					       eventService.subscribeEvent(com.ibm.mashups.iwidget.Constants.WIDGET_LOADED + "." + iwId, null, function(){iWEventingExtension.runSendEventToIWidget(pii, pageId);}, null, null);
     					     }
			          }
				  delete this.pageWindowNumberQueue[pageId];
            }
        //}
    }

    // 
    // Unsubscribe all portlets in the page from event topic and send
    // a closePage event. This function is called from taskBar.js in 
    // cleanPageResource()
    // @param pageId the page id to unsubcribe the portlets
    //
    this.unsubscribePortletsInPage=function(pageId){
        // before unsubscribe portlets, broadcast a close page framework event
        var eventObj = { name: FrameworkEventBroker.ClosePageEvent };
        this.sendFrameworkEvent(eventObj, pageId);

        // unsubscribe portlets
        var portlets = this.getPortletsFromPage(pageId);
        if(portlets){
            for(var i = 0; i < portlets.length; i++ ){
                this.unsubscribePortlet(portlets[i].pii);
            }
        }else{
            // not a state maintained page and user closed the tab
            // when it is not in focus
            for(var i in this.subscribedPortletList){
                if(this.subscribedPortletList[i].pageId == pageId){
                    delete this.subscribedPortletList[i];
                }
            }
        }
    }

    
    // 
    // Unsubscribe portlet from event topic
    // @param pii the portlet unique id
    // 
    this.unsubscribePortlet=function(pii){
        for(var i in this.subscribedPortletList){
            if(i.indexOf(pii) != -1){
                // found pii in hash map, set it to null
                delete this.subscribedPortletList[i];
            }
        }
    }

    //
    // Subscribe portlet to the event topic 
    //
    this.subscribePortlet=function(pii, pageId, portletEventHandler, eventName){
        var portletTopic	=	this.portletTopicPrefix+pii+"/"+eventName;
        var pageTopic		=   this.pageTopicPrefix+pageId+"/"+eventName;
        var allEventsTopic  =   this.pageTopicPrefix+pageId+"/"+this.acceptAllEventsId;

        var subscriberObj = { "pii": pii, "handler": portletEventHandler, "eventName": eventName, "pageId": pageId };
        this.subscribedPortletList[pii+eventName] = subscriberObj;

    };
    
/*
 * redpath Defect 241124
 * An iWidget which is wrapped in a Wortlet has underlying custom wires associated with the 
 * wortlet container, so execute those wires which were built using the TIP/ISC GUI ans restored
 * from the Server Store when this page was created.
 *
 * sourcePortletObject: is a Wortlet
 **/
    this.handleIWidgetWortletWires=function(sourcePortletObject, eventName, eventType, payload){
      var evtSettings = new JSONEventSettings(sourcePortletObject);
      var wiresForEvent = evtSettings.getCustomWires(eventName);
      var eventObject= /*TIP_DOJO_NS*/dojo.clone(payload);
      eventObject.name   = eventName;    //create the event object
      eventObject.type   = eventType;
      eventObject.source = sourcePortletObject.portletData.namespace;
      EventBroker.executeWires(wiresForEvent, sourcePortletObject,sourcePortletObject.page, eventObject);
    };

    //
    // send event
    // @param portletNamespace portlet namespace
    // @param eventObject the event object to send to the target portlet
    //
    this.sendEvent=function(portletNamespace , eventObject){

		//CR181 lets make a unique ID for this particular eventObject, so we can cache transformed events with it
		eventObject[ this.Internal_TIP_Event_Identifier_Key ] = this.eventIDTicker++;

        if(!portletNamespace){
            this.logErrorMessage(1001);// missing namespace
        }
        if(!eventObject){
            this.logErrorMessage(1002);// missing eventObject
        }
        if(!eventObject.name){
            this.logErrorMessage(1003);// missing eventObject.name
        }
         
        var sourcePortletObject 	= this.getPortletObjectByNamespace(portletNamespace);
        if ( !sourcePortletObject ) {
            this.logErrorMessage(1004); // couldn't find portlet object with specified portlet namespace
        }

        var evtSettings = new JSONEventSettings(sourcePortletObject);

        if(evtSettings.isPublishedEventDisabled(eventObject.name)){
            // publish event disabled....dont send event
            return;
        }

        /*
         * Commented out because chain of events is not currently supported
         *
        if(this.eventsStack.length < this.StackEventsLimit){
            // add new event to stack
            this.eventsStack.push({ "eventSettings": evtSettings, "sourcePortletObject": sourcePortletObject, "eventObject": eventObject });
        } else {
            return 1006; // event discarded because the number of events in stack exceeded the limit
        }
        */

        var errorCode = 0; // default to success
        if(this.sendEventInProgress){
            // currently processing sendEvent, return
            return; // success
       /*
        * Commented out because chain of events is not currently supported
        *
        }else{
             reset currentEventStackIndex to 0 so that we process the first 
             event
            this.currentEventStackIndex = 0;
        */
        }

        this.sendEventInProgress = true;

        if(!this.exceptionQueue)
            this.exceptionQueue = new EventBrokerExceptionQueue();

        // disable the source portlet to prevent any user interactions
        // this function is from portletRefresh.js
        iscPrDisablePortlet(sourcePortletObject.portletData.oid,true);

       //
       // commented out because chain of events is not currently supported
       // errorCode = this.handleEventsStack();
       //

        if(FrameworkEventBroker.isFrameworkEvent(eventObject.name)){
        		//defect 236574
						//add iWidget support 
						//246529 - move here because we don't want to broadcast the custom events. we want to send them through wires.
		       if (typeof(iWBridge)!='undefined') {                     //IWBridge code if 
		           iWBridge.eventToAllIWidgets(portletNamespace,        //sourceID
		                                       eventObject.name,        //event Name
		                                       null,                    //event type
		                                       eventObject);            //payload
		       }
            var frameworkEvent = new FrameworkEventBroker(eventObject, sourcePortletObject.portletData.oid, sourcePortletObject.page.pageData.uid);
        }else{
            this.handleSendEvent(sourcePortletObject, eventObject, evtSettings);
        }

        this.doFinishSendEvent(sourcePortletObject.portletData.oid);
	};

  //
  // Send framework event
  // @param eventObj event object
  // @param pageId page id to send to
  //
  this.sendFrameworkEvent=function(eventObj, pageId){
      if(!this.exceptionQueue)
          this.exceptionQueue = new EventBrokerExceptionQueue();
      var frameworkEvent = new FrameworkEventBroker(eventObj, null, pageId);
      this.doFinishSendEvent();
  }

    //
    // Execute the events stack
    // Currently not use because chain of events is not supported
    //
    /*
     * Commented out because chain of events is not currently supported
     *
    this.handleEventsStack=function(){
        if(this.switchPageInProgress){
            // wait until switch page is done
            return;
        }

        while(this.currentEventStackIndex < this.eventsStack.length){
            // iterate the stack
            if(this.switchPageInProgress){
                // switching page, dont process any new events
                break;
            }else{
                errorCode = this.handleSendEvent(this.eventsStack[this.currentEventStackIndex].sourcePortletObject, this.eventsStack[this.currentEventStackIndex].eventObject, this.eventsStack[this.currentEventStackIndex].eventSettings);
                this.currentEventStackIndex++;
            }
        }

        if(!this.switchPageInProgress && this.currentEventStackIndex >= this.eventsStack.length){
            // done executing the events stack
            this.doFinishSendEvent();
        }

        return errorCode;
    }
    */

    // 
    // Done sending event. Reset the sendEvent variables
    //
    this.doFinishSendEvent=function(srcPortletId){
        // Commented out because chain of events is currently not supported
        //
        // this.eventsStack.length = 0; // reset the sendEvents stack
        // this.currentEventStackIndex = 0;

        // dont turn off the sendEventInProgress flag until switch page is
        // done
        if(!this.switchPageInProgress){
            this.sendEventInProgress = false;
            this.loadPageWireInProgress = false;
            this.pageLaunched = false;
            if(srcPortletId)
                iscPrDisablePortlet(srcPortletId,false);
        }
        this.exceptionQueue.printErrors(true);
    }

    //
    // Handles all the send event operation
    // @param sourcePortletObject the source portletobject
    // @param eventObject the event object to send to the portlet
    // @param evtSettings the event settings for the sender portlet
    // @return an error code in integer
    //
    this.handleSendEvent=function(sourcePortletObject, eventObject, evtSettings, wiresForEvent){
        var sourcePageObject = sourcePortletObject.page;
        if(!wiresForEvent){
            wiresForEvent = evtSettings.getCustomWires(eventObject.name);
        }
        var switchPageId = null;
        var loadPageId = null;
        var isLoadPage = false;
        var moduleId = null;
        var taskType = 0;
        var errorCode = 0; // default to success
        var portletToNone = false;
        var switchServersidePage = false;

        // always exclude the src pii from broadcast
        var excludePii = new Array(sourcePortletObject.portletData.oid);
        var wireResult = null;
         
        if(wiresForEvent && wiresForEvent.length > 0){ 
            // execute wires
            wireResult = this.executeWires(wiresForEvent, sourcePortletObject, sourcePageObject, eventObject); 
            switchPageId = wireResult.loadPageId || wireResult.switchPageId;
            isLoadPage = (wireResult.loadPageId)?true:false;
            moduleId = wireResult.moduleId;
            taskType = wireResult.taskType;
            errorCode = wireResult.errorCode;
            portletToNone = wireResult.portletToNone;
            switchServersidePage = wireResult.switchServersidePage;
            if(!portletToNone){ // wires have no portlet to none
                for(var i in wireResult.portletsToExcludeFromBroadcast){
                    // exclude the target portlets in the wire to avoid sending 
                    // the event twice
                    excludePii.push(wireResult.portletsToExcludeFromBroadcast[i]);
                }
            }
        }

        if(switchPageId){
            // done executing wires, switch page
            this.switchPageInProgress = true;
            this.switchPageSourcePortletId = sourcePortletObject.portletData.oid;
            var focusPage = false;
            if(switchServersidePage){
                // switching to serverside page, bring the page to focus
                focusPage = true;
                // check to see if there is another instance of this page
                // opened
                var pageIdToSearch = this.getLastVisitedPage(switchPageId);
                if(pageIdToSearch){
                    // found an instance of serverside page, switch to this
                    // page
                    isLoadPage = false;
                    switchPageId = pageIdToSearch;
                }
            }
            // need to know which page we were on prior to the new page
            this.lastOpenPage = sourcePageObject.pageData.uid;

            this.handleSwitchPage(switchPageId, moduleId, taskType, isLoadPage, focusPage);
            this.pageLaunched = true; // an indicator a page was launched
        }

        if(!portletToNone && !isLoadPage){ // wires have no target portlet to none
            // execute implicit wires (supported processing events)
            if(sourcePageObject.pageData.stateMaintained == "true" || !this.pageLaunched){
                try{
                    // only broadcast if it is a state maintained page or no switch page
                   // this.broadCastEvent(sourcePageObject.pageData.uid, eventObject, excludePii);
                    this.broadcastToPage(sourcePageObject.pageData.uid, eventObject, excludePii, false, true, sourcePortletObject);
                }catch(error){
                    this.exceptionQueue.add(error);
                    this.doFinishSendEvent(sourcePortletObject.portletData.oid);
                }
            }
        }

        return errorCode;
    }

    // 
    // Executes all the wires
    // @param wiresForEvent an array of object that contains wire info
    // @param sourcePortletObject the sender portlet object
    // @param sourcePageObject the sender page object
    // @param eventObject eventObject to send to the target portlet
    // @return an object that contains 
    //         switchPageId - page id 
    //         errorCode - error code in integer
    //         portletsToExcludeFromBroadcast - an array of pii in String 
    //         portletToNone - a boolean whether the wire has portlet to none target
    //
    this.executeWires=function(wiresForEvent, sourcePortletObject, sourcePageObject, eventObject){
        var errorCode = 0; // success by default
        var switchPageId = null;
        var switchServersidePage = false;
        var moduleId = null;
        var taskType = 0;
        var portletsToExcludeFromBroadcast = new Array();
        if(wiresForEvent.portletsToExcludeFromBroadcast){
            portletsToExcludeFromBroadcast = wiresForEvent.portletsToExcludeFromBroadcast;
        }
        var currentPagePii = this.getCurrentPagePortlets(); // get all pii's on current page
        var portletToNone = false;
        var loadPageId = null;
        var result = null;

        // go through all the explicit wires
        while(wiresForEvent.length > 0){
           // var currWire = wiresForEvent[i];
            var currWire = wiresForEvent.shift();
            if (currWire.enabled == "false")
            	continue;
            //246599 - custom wire transformation affects system wires
            //prevent the event object from changing during wire execution.
            var copiedEventObj = {};
            for (var prop in eventObject){
            	copiedEventObj[prop] = eventObject[prop];
            }
            //End 246599 - custom wire transformation affects system wires
            if(currWire.target.targetType == JSONEventSettings.PortletTarget){
                // make sure the event is not sent back to the src portlet
                if(currWire.target.pii != sourcePortletObject.portletData.basePii){
                    for(var i = 0; i < currentPagePii.length; i++ ){
                      if(currentPagePii[i].basePii == currWire.target.pii){
                        // wire target portlet on same page, add to exclude portlets array.
                        // use the unique pii instead of target wire base pii because
                        // the unique pii was used to subscribe to the broadcast
                        // topic.
                        portletsToExcludeFromBroadcast.push(currentPagePii[i].pii);
                      }
                    }
                    try{
                    	//use copiedEventObj replace the eventObj
                        result = this.handlePortletTargetWire(currWire,copiedEventObj, sourcePortletObject);
                    }catch(error){
                        this.exceptionQueue.add(error);
                        continue;
                    }
                }
            }else if(currWire.target.targetType == JSONEventSettings.NavigationNodeTarget){
                if(sourcePortletObject.page.pageData.uid.indexOf(currWire.target.navigationRef) != -1){
                    // target page is the same as source page
                    for(var i = 0; i < currentPagePii.length; i++ ){
                        // add the target portlets from wire that are on the src page
                        portletsToExcludeFromBroadcast.push(currentPagePii[i].pii);
                    }
                }
                try{
                	//use copiedEventObj replace the eventObj
                    result = this.handlePageTargetWire(currWire, copiedEventObj, sourcePortletObject);
                }catch(error){
                    this.exceptionQueue.add(error);
                    continue;
                }
            }
            if(result){
                // get info from result
                switchServersidePage = result.switchServersidePage;
                if(result.switchServersidePage && !currWire.preprocessed && wiresForEvent.length > 0){
                    // load the serverside pages last 

                    // add a flag to indicate it has been looked at
                    currWire.preprocessed = true;

                    // add it to the end of the stack to be processed last
                    wiresForEvent.push(currWire);
                    // remove the last entry...will do the send event at the end if
                    // there are no other switchPage in the wires
                    this.loadPageWireToResume.pop();
                }else{
                    moduleId = currWire.target.moduleId;
                    taskType = result.taskType;
                    errorCode = result.errorCode;
                    if(result.loadPageId){
                        // need to load page, stop processing wire
                        loadPageId = result.loadPageId;
                        // add the current wire back to the stack
                        wiresForEvent.push(currWire); //Defect 254214
                        var currLoadPageWireToResume = this.loadPageWireToResume.pop();
                        // add wiresForEvent to the loadPageWireToResume so that
                        // client broker can continue processing the wires
                        currLoadPageWireToResume.wires = wiresForEvent;
                        currLoadPageWireToResume.wires.portletsToExcludeFromBroadcast = portletsToExcludeFromBroadcast;
                        this.loadPageWireToResume.push(currLoadPageWireToResume);
                        break;
                    }
                }
                if(result.switchPageId){
                    switchPageId = result.switchPageId;
                }
            }
        }
        return { "loadPageId": loadPageId, "switchPageId": switchPageId, "moduleId": moduleId, "taskType": taskType, "portletsToExcludeFromBroadcast": portletsToExcludeFromBroadcast, "errorCode": errorCode, "portletToNone": portletToNone, "switchServersidePage": switchServersidePage };

    }

    //
    // Return an array of portlet id's on current page
    // The array element value is the unique pii and the key is
    // the base pii
    // @return an array of Pii in String
    // 
    this.getCurrentPagePortlets=function(){
        return this.getPortletsFromPage(IscPages.currentPageId);
    }

    //
    // Returns an array of portlet pii that are in the specified page
    // The array element value is the unique pii and the key is
    // the base pii
    // @param pageId the page unique id
    // @return an array of pii
    //
    this.getPortletsFromPage=function(pageId){
        var pagePortlets = new Array();

        var pageObj = this.getPageObject(pageId, null, null, true);
        if(!pageObj){
          // page not found, must be a state maintained page
          return pagePortlets;
        }
        var portletElements = Portlet.getPortletElements(pageObj.element);
        var portletObject = null;
        if(portletElements && portletElements.length > 0){
            // iterate portlet elements and look for the matching pageId
            var portletCount = 0;
            for(var i=0; i < portletElements.length; i++){
                if(!portletElements[i].modelObject){ 
                    continue;
                }else if(portletElements[i].modelObject.page && portletElements[i].modelObject.portletData){
                    if(portletElements[i].modelObject.page.pageData.uid == pageId){
                    //console.debug("getPortletsFromPage=basepii="+this.BasePiiPrefix+portletElements[i].modelObject.portletData.basePii+"  pii="+portletElements[i].modelObject.portletData.oid + " pageid="+pageId + " pelement pageid="+portletElements[i].modelObject.page.pageData.uid);
                        pagePortlets[portletCount++] = { "basePii": portletElements[i].modelObject.portletData.basePii, "pii": portletElements[i].modelObject.portletData.oid, "namespace": portletElements[i].modelObject.portletData.namespace, "element": portletElements[i] };
                    }
                }
            }
        }
        return pagePortlets;
    }

    //
    // Find portlet object using the specified namespace
    // @param portletNamespace portlet namespace
    // @return an object that contains the portlet info
    //
    this.getPortletObjectByNamespace=function(portletNamespace) {
        // optimize this later
        var portletElements = Portlet.getPortletElements(/*TIP_DOJO_NS*/dojo.body());
        // iterate portlet elements and look for the matching namespace
        for(var i=0; i < portletElements.length; i++){
        	if(portletElements[i].modelObject
        		&& portletElements[i].modelObject.portletData
       			&& portletElements[i].modelObject.portletData.namespace == portletNamespace)
        	{
        		return( portletElements[i].modelObject );
        	}
        }
		return null;
    }

	//
	// Find portlet IFrame using the specified namespace
	// @param portletNamespace portlet namespace
	// @return an object that contains the portlet info
	//
	this.getPortletIFrameByNamespace=function(portletNamespace) {
		// optimize this later
		var portletElements = Portlet.getPortletElements(document.getElementsByTagName("body")[0]);
    var portletIFrame = null;
		if(portletElements && portletElements.length > 0){
			// iterate portlet elements and look for the matching namespace
			for(var i =0; i < portletElements.length; i++ ){
				if(portletElements[i].modelObject) {
					if(!portletElements[i].modelObject){ 
						continue;
					}

					if(portletElements[i].modelObject && 
							portletElements[i].modelObject.portletData &&
							portletElements[i].modelObject.portletData.namespace == portletNamespace)
					{
						var portletIFrames = /*TIP_DOJO_NS*/dojo.query( "iframe", portletElements[i] );
            for(var j=0; j < portletIFrames.length; j++){
              if(portletIFrames[j].id == (portletElements[i].modelObject.portletData.oid + "_iframe") && (portletIFrames[j].name == "isc_iframe") ){
                // found the iframe with id that contains the portlet's oid
                portletIFrame = portletIFrames[j];
                break;
              }
            }
						return( portletIFrame ) ;
					}
				}
			}
		}

		return null;
	}
    
    //
    // Find portlet object using the specified pii
    // @param pii portlet pii
    // @param pageId page id the portlet should be in
    // @param searchByOid if true, search by using unique pii
    // @return an object that contains the portlet info
    //
    this.getPortletObjectByPii=function(pii, pageId, searchByOid) {
        var pageObj = EventBroker.getPageObject(pageId, null, null, true);
		if( pageObj == null ) return( null );
        var portletElements = Portlet.getPortletElements(pageObj.element);
        var portletObject = null;
        if(portletElements && portletElements.length > 0){
            // iterate portlet elements and look for the matching pii
            var portletElement = null;
            var searchId = null;
			      for(var i =0; i < portletElements.length; i++ ){
                if(portletElements[i].modelObject){
                    portletElement = portletElements[i].modelObject;
                    if(searchByOid){
                        searchId = portletElement.portletData.oid;
                    }else{
                        searchId = portletElement.portletData.basePii;
                    }
                //console.debug('getPortletObjectByPii pii='+pii+'  portletElements basepii='+portletElement.portletData.basePii + '  portletElements pii=' +portletElement.portletData.oid+' pageid='+portletElement.page.pageData.uid );
                    if(searchId == pii) {
                        if(!pageId || portletElement.page.pageData.uid == pageId){
                            portletObject = portletElement;
                            break;
                        }
                    }
                }
            }
        }
        return portletObject;
    }
    
    //
    // Broadcast event to all portlets on the page
    // @param pageId the pageId to broadcast the event to
    // @param eventObject the event object to pass to the portlets
    // @param excludePii an array of pii's to exclude from the broadcast
    //
    this.broadCastEvent=function(pageId, eventObject, excludePii){
        var pageTopic = this.pageTopicPrefix+pageId+"/"+eventObject.name;
        var allEventsTopic = this.pageTopicPrefix+pageId+"/"+this.acceptAllEventsId;

        if(excludePii){
            for(var i in excludePii){
                // remove the portlet from the broadcasting
                if(this.subscribedPortletTopics[excludePii[i]] && this.subscribedPortletTopics[excludePii[i]][0] == eventObject.name){
                  /*TIP_DOJO_NS*/dojo.unsubscribe(this.subscribedPortletTopics[excludePii[i]]);
                }
            }
        }

        // broadcast to portlets that accept this event
        /*TIP_DOJO_NS*/dojo.publish(pageTopic, [eventObject]);

        if(excludePii){
            for(var i in excludePii){
                // subscribe the portlet back for future broadcasting
                if(this.subscribedPortletTopics[excludePii[i]][0] == eventObject.name){
                  /*TIP_DOJO_NS*/dojo.subscribe(pageTopic, window, this.subscribedPortletList[excludePii[i]]);
                }
            }
        }
    }
    
    //
    // Handles the sendEvent wire to a portlet
    // @param wire an object that contains the wire info
    // @param eventObject the eventObject to send to the portlet
    // @param srcPortletObject the sender portlet object
    // @return error code in integer
    //
    this.handlePortletTargetWire=function(wire, eventObject, sourcePortletObject){
        var results = { "taskType": 0 };
        var sourcePageId = IscPages.currentPageId;
        var targetPortletPageObj = this.getPageObject(wire.target.navigationRef, wire.target.moduleId, wire.target.taskType, false);  
        var targetPortletObj = null;
        var switchPageId = null;

 /*
  * redpath Defect 241124
  *
  * iWidget added code to handle Wortlets which have custom wires..
  * These (custom wires) eventNames are handled by the iWidget structure and are really not internal to
  * TIP/ISC other than stored as a Customer Wire by name to deliver an event for the Wortlet which it thinks is 
  * a Portlet.
  **/
  // 246529 - remove this part because we want to send iwidget events through wires.
//if (typeof(iWBridge)!='undefined') {                     //if IWBridge code  
//   var w=iWBridge.WortletId(targetPortletPageObj);       //it is a wortlet
//   if (w!=null){
//     iWBridge.handleWortletTarget(wire,eventObject, sourcePortletObject);
//     return;
//  }
//}

//console.debug("handlePortletTargetWire: targetPortletPageobj="+targetPortletPageObj+"   target page="+wire.target.navigationRef+" srcportlet app="+sourcePortletObject.portletData.moduleRef+" loadpage="+wire.target.loadPage+" switchPage="+wire.target.switchPage);
        if(!targetPortletPageObj){
            if(wire.target.switchPage == "true" || wire.target.loadPage == "true"){
                if(wire.target.stateMaintained == "true" || (wire.target.stateMaintained == "false" && wire.target.switchPage == "true")){
                    if(wire.target.stateMaintained == "false"){
                        // server side page, load & switch at the end of wire
                        // execution
                        results.switchServersidePage = true;
                    }
                    results.loadPageId = wire.target.navigationRef;
                    // page not loaded, save info for later
                    this.loadPageWireToResume.push({ "sourcePortletObject": sourcePortletObject, "sourcePageObject": sourcePortletObject.page, "eventObject": eventObject });
                    results.taskType = wire.target.taskType;
                }else{
                    // not loading server side page with switchPage false, 
                    // discard event for this wire
                    //the error breaks the IE runtime and actually is not needed
                    //this.logErrorMessage(1015, [ wire.target.navigationRef ]);
                }
            }else{
                // not loading page, discard event for this wire
                //the error breaks the IE runtime and actually is not needed
                //this.logErrorMessage(1005, [ wire.target.navigationRef ]);
            }
            return results;
        }

        targetPortletObj = this.getPortletObjectByPii(wire.target.pii, targetPortletPageObj.pageData.uid);
        //console.debug('handleTargetPortlet: pageuid='+targetPortletObj.page.pageData.uid +' targetportlet=' + wire.target.windowRef + ' wire moduleref='+wire.target.moduleId+' taskType='+wire.target.taskType);
        if(!targetPortletObj){
            // could not find portlet, portlet does not exist
            this.logErrorMessage(1006);
        }else{
            if(wire.target.switchPage == "true" && wire.target.stateMaintained == "true"){
                // only switch page when it is state maintained and switch
                // page flag is true. Server side page will come into
                // focus when the open page is opened
                if(targetPortletPageObj.pageData.uid != sourcePageId){
                    // only swith page if it is not already on the page
                    switchPageId = targetPortletPageObj.pageData.uid;
                    results.taskType = wire.target.taskType;
                }
            }
            var transformationObj = wire.target.transformationRef;
        //console.debug('handleTargetPortlet: pageuid='+targetPortletObj.page.pageData.uid +' targetportlet=' + wire.target.windowRef + ' wire moduleref='+wire.target.moduleId+' taskType='+wire.target.taskType+' transformationid='+transformationObj.uniqueName+' transformation type='+transformationObj.type);

            if(transformationObj.uniqueName && transformationObj.uniqueName != "null"){
                // there is transformation for this target, do transformation
                var transformation = new Transformation(transformationObj, eventObject, wire.source.moduleId, wire.source.portletName, wire.source.portletApplication, null, targetPortletObj.portletData.namespace, null);
                var transformationResult = transformation.doTransformation();

                // get the result from the transformation
                results.errorCode = transformationResult.errorCode;
                if(transformationResult.targetEventObject){
                    eventObject = transformationResult.targetEventObject;
                }
                results.transformationInProgress = transformationResult.transformationInProgress;
            }
            if(!results.transformationInProgress){
                // send event now if we are not doing ajax transformation
                
                //246529 - add iwidget support
								var widget = null;
								if (targetPortletObj.portletData.iwidget == "true") {
										if (iWBridge)
												iWBridge.processIWidgetWire(iWidgetUtils.piiToWidgetId(targetPortletObj.portletData.oid), eventObject.name, null, eventObject);
								} else {
										this.sendEventToPortlet(targetPortletObj.portletData.namespace, eventObject);
								}
            }
        }
        results.switchPageId = switchPageId;

        return results;
    }
    
    //
    // Handles the sendEvent wire to a page
    // @param wire an object that contains the wire info
    // @param eventObject the eventObject to send to the portlet
    // @param srcPortletObject the sender portlet object
    // @return error code in integer
    //
    this.handlePageTargetWire = function(wire,eventObject,srcPortletObject){
        var results = { "transformationInProgress": false };
        var switchPageId = null; 
        var targetPortletPageObj = this.getPageObject(wire.target.navigationRef, wire.target.moduleId, wire.target.taskType, false);  

//console.debug("handlePageTargetWire: targetPortletPageobj="+targetPortletPageObj+"   target page="+wire.target.navigationRef+" switchPage="+wire.target.switchPage+" loadPage="+wire.target.loadPage+" stateMaintained="+wire.target.stateMaintained);
        if(!targetPortletPageObj){
            // page not loaded. Load page...
            if(wire.target.switchPage == "true" || wire.target.loadPage == "true"){
                if(wire.target.stateMaintained == "true" || (wire.target.stateMaintained == "false" && wire.target.switchPage == "true")){
                    if(wire.target.stateMaintained == "false"){
                        // server side page, load & switch at the end of wire
                        // execution
                        results.switchServersidePage = true;
                    }
                    results.loadPageId = wire.target.navigationRef;
                    this.loadPageWireToResume.push({ "sourcePortletObject": srcPortletObject, "sourcePageObject": srcPortletObject.page, "eventObject": eventObject });
                    results.taskType = wire.target.taskType;
                }else{
                    // not loading server side page with switchPage false, 
                    // discard event for this wire
                    this.logErrorMessage(1015, [ wire.target.navigationRef ]);
                }
            }else{
                // not loading page, discard event for this wire
                this.logErrorMessage(1005, [ wire.target.navigationRef ]);
            }
            return results;
        } else {

            if(wire.target.switchPage == "true" && wire.target.stateMaintained == "true"){
                // only switch page when it is state maintained and switch
                // page flag is true. Server side page will come into
                // focus when the open page is opened
                if(wire.target.switchPage == "true"){
                    var sourcePageId = IscPages.currentPageId;
                    if(sourcePageId != targetPortletPageObj.pageData.uid){
                        // only switch page if it's not already on the page
                        switchPageId = targetPortletPageObj.pageData.uid;
                        results.taskType = wire.target.taskType;
                    }
                }
            }
            var transformationObj = wire.target.transformationRef;

            var excludePii = new Array(srcPortletObject.portletData.oid); // exclude src pii from broadcast
            if(transformationObj.uniqueName && transformationObj.uniqueName != "null"){
                // there is transformation for this target, do transformation
                var transformation = new Transformation(transformationObj, eventObject, wire.source.moduleId, wire.source.portletName, wire.source.portletApplication, targetPortletPageObj.pageData.uid, null, excludePii);
                var transformationResult = transformation.doTransformation();

                // Get result from transformation
                results.errorCode = transformationResult.errorCode;
                if(transformationResult.targetEventObject){
                    eventObject = transformationResult.targetEventObject;
                }
                results.transformationInProgress = transformationResult.transformationInProgress;
            }
            if(!results.transformationInProgress){
                // only broadcast event if we are not doing ajax transformation
                this.broadcastToPage(targetPortletPageObj.pageData.uid, eventObject, excludePii);
            }
        }
        results.switchPageId = switchPageId;
        return results; 
    }
    
    //
    // un-subscribe the logout event for specified portlet.
    // @param portletNamespace portlet namespace.
    this.unsubscribeLogoutEvent=function(portletNamespace){
    	var portletObj = this.getPortletObjectByNamespace(portletNamespace);
    	try{
	    	var pii = portletObj.portletData.oid;
	    	delete this.subscribedPortletList[pii+FrameworkEventBroker.LogoutEvent];
    	}catch(error){
             EventBroker.exceptionQueue.add(error);
             EventBroker.logMessageInServer(error, "unsubscribeLogoutEvent");
    	}
    }
    
    //
    // Broadcast event to all portlets in page regardless of the portlet
    // supported events
    // @param pageId page id
    // @param eventObject event object from send event
    // @param excludePii an array of pii to exclude from the broadcast
    // @param queue a boolean whether to put it in the queue to be sent
    //              after the portlets are loaded
    // @param systemWires a boolean whether this is a system wires broadcast. 
    //                    If true, only broadcast to portlets that subscribe to
    //                    this event
    // @param sourcePortletObj src portlet obj. Only applicable if
    //                         systemWires=true
    //
    this.broadcastToPage=function(pageId, eventObject, excludePii, queue, systemWires, sourcePortletObj){
        var portlets = this.getPortletsFromPage(pageId);
        var excludePiiString = "";
        if(excludePii){
            excludePiiString = excludePii.toString();
        }
        var portletHandler = null;
        var evtSettings = null;
        if(systemWires){
            if(!sourcePortletObj){
                if(portlets.length > 0){
                    // get system wires from any of the page's portlet
					sourcePortletObj = portlets[0].element.modelObject;
                }else{
                    // no portlets to get eventsettings....return
                    return;
                }
            }
            evtSettings = new JSONEventSettings(sourcePortletObj);
        }

        for (var i =0; i < portlets.length; i++ )
        {
            //forward framework events to iWidgets - rework 245979
            if ((typeof(iWBridge)!='undefined') && (portlets[i].element.modelObject.portletData.iwidget=="true"))
            {
                 //FrameWork Events that are processed
                  if (eventObject.name==FrameworkEventBroker.PortletResizeEvent)
                  {
                      var size= iscPortlet.getPortletSize(portlets[i].namespace);
                      if(size) {
                    	  var  payload = {"newWidth": size.available.w,
                    			  			"newHeight":size.available.h};
                    	  iWBridge.frameWork(iWidgetUtils.piiToWidgetId(portlets[i].pii), payload, null, "onSizeChanged", "onSizeChanged" );
                      }
                  } 
				  else if(eventObject.name==FrameworkEventBroker.ClosePageEvent) {
				  
					 var payload = {"TIP_WIDGET_WIZARD_ACTION": eventObject.TIP_WIDGET_WIZARD_ACTION};  
                	 iWBridge.frameWork(iWidgetUtils.piiToWidgetId(portlets[i].pii), payload, null, "closePage", "closePage" ); 
				  }
                  else{ 
                	  if(eventObject.name=="http://ibm.com/tip#changeTheme") 
                	  {
                		  var payload = {"prevTheme": eventObject.prevTheme, "activeTheme": eventObject.activeTheme};  
                		  iWBridge.frameWork(iWidgetUtils.piiToWidgetId(portlets[i].pii), payload, null, "changeTheme", "changeTheme" ); 
                	  }
                  }
            }

            portletHandler = null;
            if(systemWires==true && !evtSettings.isSystemWireEnabled(eventObject.name, portlets[i].basePii)){
                // systemWires but it is disabled
                continue;
            }else if(excludePiiString.indexOf(portlets[i].pii) != -1){
                continue;
            } else if(systemWires == true && !this.subscribedPortletList[portlets[i].pii+eventObject.name]){
            		// 246529 - if the target is an iWidget, then send the event via iWBridge.
                var targetPortletObj = portlets[i].element.modelObject;
                if (targetPortletObj.portletData.iwidget == "true") {
										if (iWBridge)
												iWBridge.processIWidgetWire(iWidgetUtils.piiToWidgetId(portlets[i].pii), eventObject.name, null, eventObject);
								}
                // system wires broadcast but this portlet was not subscribed to
                // to any events
                continue;
            } else if(this.subscribedPortletList[portlets[i].pii+eventObject.name]){
                portletHandler = this.subscribedPortletList[portlets[i].pii+eventObject.name].handler;
                if(systemWires == true && this.subscribedPortletList[portlets[i].pii+eventObject.name].eventName != eventObject.name){
                    // system wires broadcast but this portlet was not subscribed to
                    // this event
                    continue;
                }
            }
            if(queue == true){
                // add it to portletEventQueue
                this.portletEventQueue[portlets[i].pii] = eventObject;
            }else{
            		// 246529 - if the target is an iWidget, then send the event via iWBridge.
                var targetPortletObj = portlets[i].element.modelObject;
                if (targetPortletObj.portletData.iwidget == "true") {
										if (iWBridge)
												iWBridge.processIWidgetWire(iWidgetUtils.piiToWidgetId(portlets[i].pii), eventObject.name, null, eventObject);
										continue;
								}
            	
                if(!portletHandler){
                    portletHandler = portlets[i].namespace+this.ProcessHandler;
										if(!this.isProcessHandlerExists(portlets[i].namespace)){
												// portletHandler is not defined
                				this.exceptionQueue.add(1024, [portletHandler]);
                				EventBroker.logMessageInServer(1024, "broadcastToPage", [portletHandler]);
												continue;
										}
                }
               	// call the function directly
                try{
					var evalWin = null;
					// SM_IF2 IFrames now specified on a portlet level rather than universally.
					var portletIFrame = this.getPortletIFrameByNamespace( portlets[i].namespace );
					if( portletIFrame != null || ISC_CONSOLE_SM_USEIFRAMES ) {
						evalWin = portletIFrame.contentWindow;
					}
					else {
						evalWin = window;
					}

					"function" === typeof evalWin[portletHandler] && evalWin[portletHandler](eventObject);
                }catch(error){
                    // catch the error if the portlet processEvent 
                    // handler has errors
                    EventBroker.logErrorMessage(1026, [portletHandler]);
                }finally{
                    // continue the broadcast despite the errors
                    continue;
                }
            }
        }
        
    }

    //
    // Look up the page object given the page id
    // @param pageId page id
    // @param moduleId app id
    // @param taskType page task type
    // @param serversidePage a boolean whether the search should use 
    // document body if IscPages.getPageObjectById did not find it. This is
    // used especially for serverside pages because IscPages has trouble 
    // finding serverside pages. Only applies to when invoke from
    // getPortlets... 
    // @return an object that contains the page info
    //
    this.getPageObject = function(pageId, moduleId, taskType, deepSearch) {
        var pageIdToSearch = pageId;
   //     if(taskType > 0){
            // multitask page, look for the last visited page
            pageIdToSearch = this.getLastVisitedPage(pageId);
            /*
             * I dont think this is needed since adding the page will also
             * show up in breadcrumb stack...
            if(!pageIdToSearch){
                // this might be a newly loaded page, try page list
                pageIdToSearch = this.getLastOpenPage(pageId);
                if(!pageIdToSearch){
                    // page has never been loaded
                    return null;
                }
            }
            */
    //    }else if(moduleId){
        if(!pageIdToSearch){
            pageIdToSearch += ";" + moduleId;
        }
        var pageObject = null;
        pageObject = IscPages.getPageObjectById(pageIdToSearch);

        // Need this for server side page because IscPages.getPageObject may
        // not find it
        if(!pageObject && deepSearch){
            // not found in IscPages object, try searching through the portlets
            var portletElements = Portlet.getPortletElements(document.getElementsByTagName("body")[0]);
            if ( portletElements && portletElements.length > 0){
                // iterate portlet elements and look for the matching pageid
                var pageDataUid = null;
                var pageDataUniquePageName = null;
                for(var i = 0; i < portletElements.length; i++ ){
                  if(portletElements[i].modelObject) {
                    if ( portletElements[i].modelObject.page ) {
                        pageDataUid = portletElements[i].modelObject.page.pageData.uid;
                        pageDataUniquePageName = portletElements[i].modelObject.page.pageData.uniquePageName;
                    } else {
                        continue;
                    }
                    if ( (pageDataUid == pageId) || (pageDataUniquePageName == pageId) ) {
                        pageObject = portletElements[i].modelObject.page;
                        break;
                    }
                  }
                }
            }
        }
        return pageObject;
    }
	
    //
    // Returns the last visited page id for the specified navigation name
    // @param navigationRef navigation name
    // @return the last visited page id. null if the page has never been loaded
    //
    this.getLastVisitedPage=function(navigationRef){
        var lastVisitedPageStack = this.getLastVisitedPageStack();
        if(lastVisitedPageStack == null){
            return null;
        }
        var lastVisitedPageId = null;
        var i = 0;
        while(lastVisitedPageStack.length > 0){
i++;
            currentId = lastVisitedPageStack.pop();
            if(currentId.indexOf(navigationRef) != -1){
                lastVisitedPageId = currentId;
                break;
            }
        }
        return lastVisitedPageId;
    }

    //
    // Returns the last open page id for the specified navigation name
    // @param navigationRef navigation name
    // @return the last open page id. null if the page has never been loaded
    //
    this.getLastOpenPage=function(navigationRef){
        var pageList = this.getPageList();
        var lastOpenPageId = null;
        while(pageList.length > 0){
            currentId = pageList.pop();
            if(currentId.indexOf(navigationRef) != -1){
                lastOpenPageId = currentId;
                break;
            }
        }
        return lastOpenPageId;
    }

    //
    // Return an array of page id's that was last visited
    //
    this.getLastVisitedPageStack=function(){
        if(!parent.taskbar) {
            // for some reason, taskbar hasn't loaded yet. Return empty array
            return new Array();
        }
        var taskbarJSONElement = parent.taskbar.document.getElementById("IscTaskbar");
        var pageStack = {};
        if(taskbarJSONElement){
            eval("pageStack="+taskbarJSONElement.getAttribute("pageStack"));
        }
        return pageStack.lastVisitedPage;
    }

    //
    // Return an array of page id's that is opened
    //
    this.getPageList=function(){
        if(!parent.taskbar) {
            // for some reason, taskbar hasn't loaded yet. Return empty array
            return new Array();
        }
        var taskbarJSONElement = parent.taskbar.document.getElementById("IscTaskbar");
        var pageStack = {};
        if(taskbarJSONElement){
            eval("pageStack="+taskbarJSONElement.getAttribute("pageStack"));
        }
        return pageStack.pageList;
    }

    // 
    // this is called after executing all the wires
    // @param pageId the page id to load
    // @param moduleId the topology app id
    // @param taskType the page taskType
    // @param isLoadPage a boolean whether this will be a load page
    // @param focusPage a boolean whether to focus the page for load page
    //
    this.handleSwitchPage = function(pageId, moduleId, taskType, isLoadPage, focusPage){ 
        var taskId = null; 
        var navInfo = this.getNavigationInfo(pageId);
        taskId = navInfo.taskId;
        pageId = navInfo.navRef;

        if(isLoadPage){
            // this page hasn't been loaded yet. Load page
            DynamicUI.launchPage(pageId,moduleId,this,EventBroker.openPageCallback, focusPage, this.lastOpenPage );
        }else{
            DynamicUI.switchPage(pageId, moduleId, taskId, this, this.openPageCallback);
        }
    }

    //
    // Parse the pageId for navigation id and task id
    // Returns the page info in an object with variables
    // navRef - navigation id
    // moduleId - module id. null if not available
    // taskId - task Id. null if it is not in the pageid
    // @param pageId the page id
    // @return the page info in an object with variables
    //
    this.getNavigationInfo=function(pageId){
        var tokens = pageId.split(";");
        var navInfo = { "navRef": tokens[0] };
        if(tokens.length > 1){
            navInfo.moduleId = tokens[1];
        }
        if(tokens.length > 2){
            navInfo.taskId = tokens[2];
        }
        return navInfo;
    }

    //
    // An ajax callback function to render the new page and call
    // resumeSendEvent function
    //
    this.openPageCallback=function(pageId){
        // Done switching page... Continue with the events stack 
        if(EventBroker.lastOpenPage == pageId){
            // page did not open. Need to log this
            EventBroker.logMessageInServer(1028, "openPageCallback");
            EventBroker.exceptionQueue.add(1028);

            // resume the wires
            EventBroker.resumeSendEvent(true);
        }else{
            EventBroker.pageEventQueue[pageId] = { "executeWires": true };
        }
        EventBroker.switchPageInProgress = false;

        if(EventBroker.loadPageWireToResume.length == 0){
            // no wires to resume, continue with the events stack 
            // Commented out because chain of events is not currently supported
            // EventBroker.handleEventsStack();
            EventBroker.doFinishSendEvent(EventBroker.switchPageSourcePortletId);
        }
        
        //250636, call the runSendEventToPage when the page is completely launched.
        var numberOfWindows = EventBroker.pageWindowNumberQueue[pageId];
        //251467, IE sets pageWindowNumberQueue before the openPageCallback, so we call runSendEventToPage in content.jsp for IE
        if ((typeof(numberOfWindows) != "undefined") && !/*TIP_DOJO_NS*/dojo.isIE) {
            EventBroker.runSendEventToPage(pageId, numberOfWindows);
        }
    }

    //
    // Invoke when the portlet calls subscribePortletToAllEventsTopic function. This  
    // provide a way to resume processing the wires after the page is loaded
    // @param removeFirstWire a boolean whether to remove the first wire.
    //        This is mainly used by openPageCallback where the page may
    //        not open and we need to ignore the wire that open this page
    //
    this.resumeSendEvent=function(removeFirstWire){
        // Commented out because chain of events is not currently supported
        // EventBroker.handleEventsStack();
        if(EventBroker.loadPageWireToResume.length > 0){
            var wireToResume = EventBroker.loadPageWireToResume.pop();
            EventBroker.loadPageWireInProgress = true;
            try{
                if(removeFirstWire == true){
                    // remove the first wire to avoid executing it
                    // Reason...read above
                    wireToResume.wires.shift();
                }
                EventBroker.handleSendEvent(wireToResume.sourcePortletObject, wireToResume.eventObject, null, wireToResume.wires);
            }catch(error){
                EventBroker.exceptionQueue.add(error);
                EventBroker.logMessageInServer(error, "resumeSendEvent");
            }finally{
                EventBroker.doFinishSendEvent(wireToResume.sourcePortletObject.portletData.oid);
            }
        }
    }

    //
    // Send event to specified portlet
    // @param namespace portlet namespace
    // @param eventObject the eventObject to send to the portlet
    //
    this.sendEventToPortlet=function(namespace, eventObject){
    
        var portletProcessHandler = namespace + this.ProcessHandler;
        if(this.isProcessHandlerExists(namespace)){
            try{
				var evalWin = null;
				// SM_IF2 IFrames now specified on a portlet level rather than universally.
				var portletIFrame = this.getPortletIFrameByNamespace( namespace );
				if( portletIFrame == null ) {
					// Unable to find portlet's iframe, using traditional model
					evalWin = window;
				}
				else {
					evalWin = portletIFrame.contentWindow;
				}

				evalWin[portletProcessHandler](eventObject);
            }catch(error){
                this.logErrorMessage(1024, [portletProcessHandler]);
            }
        }
    }

    //
    // Returns the process handler function name
    //
    this.getProcessHandlerName=function(namespace){
        return namespace+this.ProcessHandler;
    }

    //
    // Returns a boolean whether the process handler function for the
    // specified namespace exists
    //
    this.isProcessHandlerExists=function(namespace){
		try {
			var evalWin = null;
			//SM_IF2 IFrames now specified on a portlet level rather than universally.
			var portletIFrame = this.getPortletIFrameByNamespace( namespace );
			if( portletIFrame == null ) {
				// Unable to find portlet's iframe, using traditional model
				evalWin = window;
			}
			else {
				evalWin = portletIFrame.contentWindow;
			}

			var handlerFunc = evalWin[ this.getProcessHandlerName( namespace ) ];
			return( typeof( handlerFunc ) != "undefined" );
		}
		catch( error ) {
			return( false );
		}
    }

    //
    // Check if all the portlets are loaded in the specified page
    // by checking the processEventHandler. NOTE: Some portlets
    // may not implement the processEventHandler. In this case, we
    // still assume the portlet was not loaded. This function is 
    // mainly used in launchPageFrameworkEventCallback to make sure
    // all processEventHandlers are loaded
    // @param pageId page id to check the portlets
    //
    this.portletsLoaded=function(pageId){
        var portlets = this.getPortletsFromPage(pageId);
        for(var i = 0; i < portlets.length; i++ ){
            if(!this.isProcessHandlerExists(portlets[i].namespace)){
                return false;
            }
        }
        return true;
    }

    //
    // Log error message in javascript error console. This will convert the
    // code to error message
    // @param errorCode error code in integer
    // @param params an array of parameters to substitute in the message
    this.logErrorMessage=function(errorCode, params){
        throw new EventBrokerException(errorCode, params);
    }

    //
    // Log error message in server
    // @param errorCode error code in integer or error message
    // @param methodName method name where this function was called from
    // @param params an array of parameters to substitute in the message
    //
    this.logMessageInServer=function(errorCode, methodName, params){
        if(!methodName){
            methodName = "";
        }
        var msg = errorCode;
        if(!isNaN(errorCode)){
            // it is a number, get message
            msg = new EventBrokerException(errorCode, params);
        }

        msg = encodeURIComponent(msg);
        var eventActionUrl = Transformation.EventActionUrl + "?";
        eventActionUrl += Transformation.EventAction_ActionParam + "=logMessage&";
        eventActionUrl += Transformation.EventAction_MsgParam + "=" + msg + "&";
        eventActionUrl += Transformation.EventAction_MethodNameParam + "=" + methodName;
	eventActionUrl += "&XSS="+top.window.XSS;
	    /*TIP_DOJO_NS*/dojo.xhrGet( {
	        url: eventActionUrl,
	        load: /*TIP_DOJO_NS*/dojo.hitch(this, this.logMessageInServerCallback), 
	        handleAs: "text",
            timeoutSeconds: 10,
            timeout: /*TIP_DOJO_NS*/dojo.hitch(Transformation, Transformation.handleTimeout)
	    } );
    }

    this.logMessageInServerCallback=function(data, ioArgs){
        // expect nothing back, do nothing here
    }

    //
    // A common function to determine if firebug was installed
    // @return a boolean whether firebug was installed
    //
    this.isFirebug=function(){
        if( ("console" in window) && ("firebug" in console) ){
            return true;
        }else{
            return false;
        }
    }

    //
    // Returns the transformation info 
    // @param transformationUniqueName transformation Unique Name
    // @param transformationLocationName transformation location Name
    // @param handler a call back function after the client broker got the info
    // @return an array 
    this.getTransformation=function(transformationUniqueName, transformationLocationName, handler){
        var eventActionUrl = Transformation.EventActionUrl + "?";
        eventActionUrl += Transformation.EventAction_ActionParam + "=getTransform&" +
                          "locationUniqueName=" + transformationLocationName +
	                  "&transformUniqueName=" + transformationUniqueName;
		eventActionUrl += "&XSS="+top.window.XSS;

        var transformationObj = new Transformation();
        transformationObj.getTransformationHandler = handler;
        var handler = transformationObj.getTransformationInfoCallback;
        var timeoutHandler = transformationObj.handleTimeout;

		//CR181 begin
		// Get the transformation string from the cache
		var transformationString = null;
		transformationObj.transformStringCacheKey1 = transformationUniqueName;
		transformationObj.transformStringCacheKey2 = transformationLocationName;
		var transformationCacheId = transformationObj.transformStringCacheKey1 + "   " + transformationObj.transformStringCacheKey2;

		//get the transform string from cache or create the transform cache entry
		if (typeof this.transformStringCache[transformationCacheId] == "undefined") {
		  this.transformStringCache[transformationCacheId] = {"gettingTransform": false};
		} else {
		  transformationString = this.transformStringCache[transformationCacheId].transformationString;
		}
		//CR181 end

		//CR181
		// If got the transformation string from the cache, pass it to the handler
		if( typeof transformationString != "undefined" && transformationString != null ) {
			console && console.log && console.log("Transformation retrieved from cache.");
			setTimeout(dojo.hitch(transformationObj, "getTransformationInfoCallback", transformationString, {xhr:{status:200}}),0);//CR181, simulate AJAX call by settimeout
		}
		// If the transformation string was not in the cache, get it via ajax and pass it to the handler
		else {
		  //CR181 begin
		  //if the previous request is not finished, push the handler in queue.
    	if (this.transformStringCache[transformationCacheId].gettingTransform) {
    	    EventBroker.transformsQueue.push({
    	    "transformationUniqueName": transformationUniqueName,
    	    "transformationLocationName": transformationLocationName,
    	    "handler": transformationObj.getTransformationHandler
    	  });
    	  
    	  return;
    	}
    	
    	this.transformStringCache[transformationCacheId].gettingTransform = true;
    	//CR181 end
    	
			// Original no-caching operation
			/*TIP_DOJO_NS*/dojo.xhrGet( {
				url: eventActionUrl,
				load: /*TIP_DOJO_NS*/dojo.hitch(transformationObj, handler),   
				handleAs: "text",
				timeoutSeconds: 5,
				timeout: /*TIP_DOJO_NS*/dojo.hitch(this, timeoutHandler)
			} );
		}
    }

    //
    // Returns all the transformation Id's configured in the wire-definition file 
    // @param handler a call back function after the client broker got the info
    // @return an array of transformation Id's in String
    this.getAllTransformations=function(handler){
        var eventActionUrl = Transformation.EventActionUrl + "?";
        eventActionUrl += Transformation.EventAction_ActionParam + "=getAllTransform"; 
 	eventActionUrl += "&XSS="+top.window.XSS;

        var transformationObj = new Transformation();
        transformationObj.isGetAllTransformations = true;
        transformationObj.getTransformationHandler = handler;
        var handler = transformationObj.getTransformationInfoCallback;
        var timeoutHandler = transformationObj.handleTimeout;

	    /*TIP_DOJO_NS*/dojo.xhrGet( {
	        url: eventActionUrl,
	        load: /*TIP_DOJO_NS*/dojo.hitch(transformationObj, handler), 
	        handleAs: "text",
            timeoutSeconds: 5,
            timeout: /*TIP_DOJO_NS*/dojo.hitch(this, timeoutHandler)
	    } );
    }

    //
    // Execute Transform 
    // @param transformInfo An object that contains the following:
    // uniqueName: transform unique name
    // locationUniqueName: transform location unique name
    // eventObj: event object to pass in
    // srcPortletNamespace: the namespace of the portlet that is calling this transform
    // handler: the call back function. The function arg will receive the new eventObj
    //
    this.executeTransform=function(transformInfo){
        var transformationObj = new Transformation();
        transformationObj.transformInfo = transformInfo;
        this.getTransformation(transformInfo.uniqueName, transformInfo.locationUniqueName, /*TIP_DOJO_NS*/dojo.hitch(transformationObj, transformationObj.executeTransformCallback));
    }

    // 
    // Refresh portlet
    // @param namespace portlet namespace
    //
    this.selfRefresh=function(namespace){
        if(!namespace){
            this.logErrorMessage(1012);
        }
        var portletObj = this.getPortletObjectByNamespace(namespace);
        
        if(portletObj){
            var pii = portletObj.portletData.oid;
            DynamicUI.refreshPortlet(pii,portletObj.page.pageData.uid,null,null,null);
        }else{
            this.logErrorMessage(1013);
        }
    }

    //
    // Returns an array of Wires based on the specified pageid and event
    // in JSON object format
    // @param pageId page id 
    // @param eventName event name 
    // @param systemWires true, return systems wires only. False
    //                    return custome wires only
    //
    this.getPageWires=function(pageId, eventName, systemWires){
        if(!pageId || !eventName){
            // need pageId and eventName
            this.logErrorMessage(1027);
        }
        var portletList = this.getPortletsFromPage(pageId);
        var wireList = new Array();
        var wireForEvent;
        for(var i = 0; i < portletList.length; i++ ){
            wireForEvent = this.getPortletWires(portletList[i].pii, pageId, eventName, systemWires);
            for(var k in wireForEvent){
                wireList.push(wireForEvent[k]);
            }
        } 
        return wireList;
    }

    //
    // Returns an array of Wires based on the specified portlet and event
    // in JSON object format
    // @param pii portlet unique pii (NOT the basepii) 
    // @param eventName event name 
    // @param systemWires true, return systems wires only. False
    //                    return custome wires only
    //
    this.getPortletWires=function(pii, pageId, eventName, systemWires){
        var sourcePortletObject 	= this.getPortletObjectByPii(pii, pageId);
        if ( !sourcePortletObject ) {
            this.logErrorMessage(1004); // couldn't find portlet object with specified portlet pii
        }
        var evtSettings = new JSONEventSettings(sourcePortletObject);
        var wiresList;
        if(systemWires == true){
            // get disabled wires
            wiresList = evtSettings.getSystemWires(eventName);
            // create enabled system wires
            for(var i in this.subscribedPortletList){
                if(this.subscribedPortletList[i].eventName == eventName){
                    var wireJson = { "type": "wire", 
                                     "wireType": "system",
                                     "enable": true,
                                     "publishingEvents": evtSettings.supportedPublishingEvents }; 
                  
                    wireJson.wireSource = { "type": "wireSource", 
                                            "wireSourceType": "0",
                                            "sourceEventName": eventName,
                                            "pii": pii,
                                            "navigationElementRef": sourcePortletObject.page.pageData.uid,
                                            "windowElementRef": sourcePortletObject.portletData.portletName };
                    wireJson.wireTarget = { "type": "wireTarget", 
                                            "targetType": "1", 
                                            "navigationElementRef": this.subscribedPortletList[i].pageId, 
                                            "windowElementRef": "", 
                                            "pii": this.subscribedPortletList[i].pii }; 
                    wiresList.push(wireJson);
                }
            }
        }else{
            // get enabled wires
            wiresList = evtSettings.getCustomWires(eventName);
        }
        return wiresList;
    }
};


//
// EventBroker exception based on error code
// @param errorCode error code as listed in EventBrokerException
// @param params an array of parameters to substitute in the message
function EventBrokerException(errorCode, params) {
       this.name="EventBrokerException";
       
       _toString = function(){
            var msg = EventBrokerException.formatMessage(EventBrokerException.Messages[errorCode], params); 
            return this.name + " - " + msg;
       }
       
       this.toString=_toString;
}

//
// A common method to format the message. 
// Example: msg="Error {0}: Failed to load {1}", params=[ "1", "dojo" ]
// This will return "Error 1: Failed to load dojo
// @param msg a string
// @param params an array of string to be used to substitute into the msg
//
EventBrokerException.formatMessage=function(msg, params){
    if(params){
        for(var i in params){
            msg = msg.replace("{"+i+"}", params[i]);
        }
    }
    return msg;
}

EventBrokerException.ERROR_MSG_QUEUE = "[Error {0}]";
EventBrokerException.Messages = new Array();
EventBrokerException.Messages[1001] = "Missing portlet namespace in sendEvent.";
EventBrokerException.Messages[1002] = "Missing event object in sendEvent.";
EventBrokerException.Messages[1003] = "Missing event name in the eventObject.";
EventBrokerException.Messages[1004] = "Couldn't find the portlet object where the sendEvent was called. It is most likely the namespace was invalid.";
EventBrokerException.Messages[1005] = "This page {0} was not loaded and loadPage or switchPage is false.";
EventBrokerException.Messages[1006] = "Target portlet does not exist.";
EventBrokerException.Messages[1007] = "Couldn't find the transformation information for the source portlet.";
EventBrokerException.Messages[1008] = "Unknown transformation type. Possible reason: can not find transforamtion in package.";
EventBrokerException.Messages[1009] = "Transformation Ajax call failed.";
EventBrokerException.Messages[1010] = "Ajax call to Transformation service timed out.";
EventBrokerException.Messages[1011] = "Ajax call to get transformation info failed.";
EventBrokerException.Messages[1012] = "Portlet namespace is needed to refresh the portlet.";
EventBrokerException.Messages[1013] = "Couldn't find the portlet to refresh.";
EventBrokerException.Messages[1014] = "Missing NavigationNode in eventObject.";
EventBrokerException.Messages[1015] = "Event cannot be sent to server side page {0} that has switchPage=false.";
EventBrokerException.Messages[1016] = "Transformation did not return the JSON string.";
EventBrokerException.Messages[1017] = "Unable to find the new page Id. Cannot send event to new page.";
EventBrokerException.Messages[1018] = "Launch portlet framework event requires portletAppId in the event object.";
EventBrokerException.Messages[1019] = "Launch portlet framework event requires portletName in the event object.";
EventBrokerException.Messages[1020] = "Switch page framework event cannot send event because the page was not loaded.";
EventBrokerException.Messages[1021] = "Launch page framework event cannot send event: Cannot find page object for the new page.";
EventBrokerException.Messages[1022] = "Transformation error occurred while converting JSON string to an object. Reason: {0}. Invalid JSON: {1}";
EventBrokerException.Messages[1023] = "Get transformation error occurred while converting JSON string to an object. Reason: {0}. Invalid JSON: {1}";
EventBrokerException.Messages[1024] = "Send event error: Process handler function: {0} does not exist. The portlet may not be fully loaded or there is no process handler function in this portlet.";
EventBrokerException.Messages[1025] = "Process event function: {0} is not defined or the portlet did not finished loading.";
EventBrokerException.Messages[1026] = "Send event error: Process handler function: {0} does not exist. The portlet may not be fully loaded or there is no process handler function in this portlet. It is possible that there is an error occurred in the process handler function";
EventBrokerException.Messages[1027] = "EventBroker.getPageWires requires the pageId and event name";
EventBrokerException.Messages[1028] = "Failed to open page. You may not have permission to open this page or there is an error occurred while opening the page.";

// 
// Save all the errors and print it out later
//
function EventBrokerExceptionQueue() {
    this.exceptionList = new Array();

    //
    // Add errors to the queue
    //
    this.add=function(errorCode, params){
        if(isNaN(errorCode)){
            error = errorCode;
        }else{
            error = new EventBrokerException(errorCode, params);
        }
        this.exceptionList.push(error);
    }

    //
    // throw exception with all the errors
    // @param clearQueue a boolean whether to clear the queue after printing
    // the errors
    //
    this.printErrors=function(clearQueue){
        if(this.exceptionList.length == 0) {
            return;
        }
        var errors = this.exceptionList[0];
        var msg = null;
        var startIndex = 1;
        var errorIndex = 1;
        if (this.exceptionList.length > 1)
            errors =
            EventBrokerException.formatMessage(EventBrokerException.ERROR_MSG_QUEUE, [errorIndex++]) + errors;

        if(clearQueue){
            // remove 1st error
            this.exceptionList.shift();
            startIndex = 0;
        }
        var queueSize = this.exceptionList.length;
        for(var i = startIndex; i < queueSize; i++){
            if(clearQueue)
                msg = this.exceptionList.shift();
            else
                msg = this.exceptionList[i];
            errors += "\n";
            errors +=
            EventBrokerException.formatMessage(EventBrokerException.ERROR_MSG_QUEUE, [errorIndex]) + msg;
        }
        throw errors;
    }

    //
    // Clear message queue
    //
    this.clearQueue=function(){
        this.exceptionList = [];
    }
}

//
// A wrapper for the wires JSON
// @param portletObj the source portlet object
//
function JSONEventSettings(portletObj) {

    this.id = "eventSettings";
    this.portletObj = portletObj;
    this.wires = null;
    this.supportedPublishingEvents = null;
    this.supportedProcessingEvents = null;
  
    this.init = function() {
        this.initSupportedEvents(portletObj.eventSettings);
        this.initWires(portletObj.eventSettings);
    }

    this.initSupportedEvents = function(eventSettingsObj){
        this.supportedPublishingEvents = eventSettingsObj.publishingEvents;
        this.supportedProcessingEvents = eventSettingsObj.processingEvents;
    }

    this.initWires = function(eventSettingsObj) {
        this.wires = eventSettingsObj.wires;
    }

    //
    // Returns true if the system wire for the specified event for
    // for target portlet is enabled
    // @param eventName
    // @param pii target portlet pii
    //
    this.isSystemWireEnabled=function(eventName, pii){
        var sysWires = this.getSystemWires(eventName);
        var sysWireEnabled = true;
        for(var i = 0; i < sysWires.length; i++ ){
            if(sysWires[i].target.pii == pii && sysWires[i].enabled == "false"){
                sysWireEnabled = false;
                break;
            }
        }
        return sysWireEnabled;
    }

    //
    // Returns an array of system wires in JSON given the event
    // Note: This will only return the disabled system wires
    // @eventName event name for the system wires 
    //
    this.getSystemWires=function(eventName){
        var systemWires = this.getWiresForEvent(eventName, true);
        return systemWires;
    }

    //
    // Returns an array of custom wires in JSON given the event
    // Note: This will only return the enabled custome wires
    // @eventName event name for the custom wires 
    //
    this.getCustomWires=function(eventName){
        var customWires = this.getWiresForEvent(eventName, false);
        return customWires;
    }

    //
    // Returns the wires for the specified eventName
    // @param eventName event name 
    // @param systemWiresOnly a boolean whether to return systemWires
    //        only or false for custom wires. If null, return all wires
    // @return an array of Object that contains the wire info
    //
    this.getWiresForEvent = function(eventName, systemWiresOnly) {
        if (this.wires == null){
            return null;
        }
        
        var wiresForEvent = new Array();
        var addWire = true;
        for(var i = 0; i < this.wires.length; i++ ){
            addWire = true;
            if(this.wires[i] && this.wires[i].source && this.wires[i].source.sourceEventName == eventName){
                if(systemWiresOnly == null){
                    // always add wire if flag is not defined
                    addWire = true;
                }else if(systemWiresOnly == true && this.wires[i].type!=1){
                    // system wire only but this is not type=1
                    // Hence not a system wire
                    addWire = false;
                }else if(systemWiresOnly == false && this.wires[i].type!=0){
                    // custom wire only but this is not type=0
                    // Hence not a custom wire
                    addWire = false;
                }
                if(addWire){
                  this.wires[i].publishingEvents=this.supportedPublishingEvents;
                  wiresForEvent.push(this.wires[i]);
                }
            }
        }
    
        return wiresForEvent
    }

    //
    // Check if this event is a supported publishing event
    // @param eventName event name
    // @return a boolean whether this event is a supported publising event
    // 
    this.isPublishedEventDisabled = function(eventName) {
        var disabled = false;

        if(this.supportedPublishingEvents && this.supportedPublishingEvents.length > 0){
            for(var i = 0; i < this.supportedPublishingEvents.length; i++ ){
                if(this.supportedPublishingEvents[i].eventName == eventName){
                    if(this.supportedPublishingEvents[i].enabled == "false"){
                        disabled = true;
                        break;
                    }
                }
            }
        }
        return disabled;
    }

    // initialize this class
    this.init();

}
// target types
JSONEventSettings.FrameworkTarget = 0;
JSONEventSettings.PortletTarget = 1;
JSONEventSettings.NavigationNodeTarget = 2;
JSONEventSettings.NoTarget = 3;

// source types
JSONEventSettings.PortletSource = 0;
JSONEventSettings.FrameworkSource = 1;



// FrameworkEventBroker class - stores framework event info and
// handles the sendevent after completing the framework event operations
// @param eventObject the event object from sendEvent
// @param sourcePortletId the source portlet id
//
function FrameworkEventBroker(eventObject, sourcePortletId_, currentPageId){
    this.event = eventObject.name;
    this.sourcePortletId = sourcePortletId_;
    this.eventObj = eventObject;
    this.targetPageId = null;
    this.targetPortletId = null;
		this.currentPageId = currentPageId;
    this.sendEvent = true;
    this.launchPortletAfterPageLaunched = false;

    //
    // Handles the framework event 
    //
    this.handleFrameworkEvent=function(){
        var eventName = this.eventObj.name;
        if(FrameworkEventBroker.LaunchPageEvent == eventName){
            this.handleLaunchPageFrameworkEvent(true);
        }else if(FrameworkEventBroker.SwitchPageEvent == eventName){
            this.handleSwitchPageFrameworkEvent();
        }else if(FrameworkEventBroker.LaunchPortletEvent == eventName){
            this.handleLaunchPortletFrameworkEvent();
        }else if(FrameworkEventBroker.SetTitleEvent == eventName){
            this.handleSetTitleFrameworkEvent();
        }else{
            // just broadcast the event to all the portlets
            this.handleUnknownFrameworkEvent();
        }

    }

    //
    // Handles the launchPage framework event
    // @param sendEvent a boolean whether to send event after the page
    // was launched
    //
    this.handleLaunchPageFrameworkEvent=function(sendEvent){
        if(!this.eventObj.NavigationNode){
            EventBroker.logErrorMessage(1014);
        }
        this.sendEvent = sendEvent;

        var taskID = this.eventObj.pageInstanceRef;
        var doSwitchPage = false;
        var lastVisitedPageStack = EventBroker.getLastVisitedPageStack();
        var pageIdToLoad = null;
        while(lastVisitedPageStack.length > 0){
            currentId = lastVisitedPageStack.pop();
            if(currentId.indexOf(this.eventObj.NavigationNode) != -1){
                // match the page id in the breadcrumb stack
                pageIdToLoad = currentId;
                if(!taskID){
                    if(this.launchPortletAfterPageLaunched){
                        // launching portlet after page launched..
                        // keep this page id 
                        doSwitchPage = true;
                        break;
                    }else{
						//254096
                        // reset pageIdToLoad, need to launch a new
                        // page
                        pageIdToLoad = null;
						
						// keep this page id 
					  //  doSwitchPage = true;
					//	break;
                    }
                }else if(pageIdToLoad.indexOf(taskID) != -1 ){
                    // match the taskId, stop the search
                    doSwitchPage = true;
                    break;
                }else{
                    // reset pageIdToLoad, need to launch a new
                    // page
                    pageIdToLoad = null;
                }
            }
        }
        var navInfo = null;
        if(pageIdToLoad){
            // page already exists, save the page id for send event later
            this.targetPageId = pageIdToLoad;
        }else{
            this.targetPageId = this.eventObj.NavigationNode;
        }
        // parse the page Id for moduleId and nav id
        navInfo = EventBroker.getNavigationInfo(this.targetPageId);
        if(doSwitchPage){
            // switch page if we have the task id
            DynamicUI.switchPage(navInfo.navRef, navInfo.moduleId,navInfo.taskId,this, this.launchPageFrameworkEventCallback);
        }else{
            // launch page
            DynamicUI.launchPage(this.targetPageId,navInfo.moduleId,this,this.launchPageFrameworkEventCallback, this.eventObj.switchPage, this.currentPageId );
        }
    }

    this.launchPageFrameworkEventCallback=function(pageId){
		var METHODNAME = "FrameworkEventBroker.launchPageFrameworkEventCallback ";
		//console.log( METHODNAME + "Entry, pageId : " + pageId );

        if(this.launchPortletAfterPageLaunched){
            // this was launched from launchPortlet
            if(this.targetPageId != IscPages.currentPageId){
                // temporary fix for a weird problem where
                // the current page becomes the welcome page!
                // 
                this.handleLaunchPageFrameworkEvent(false);
                return;
            }
            delete this.eventObj.NavigationNode;
            delete this.eventObj.switchPage;
            this.handleLaunchPortletFrameworkEvent();
            return;
        }
        this.targetPageId = pageId;
        if(this.sendEvent == false) return;
        var pageInfoObj = { "eventObj": this.eventObj };
        EventBroker.pageEventQueue[pageId] = pageInfoObj;
		// EventBroker.pageEventQueue[pageId].eventSentCount = 0;	/* This was missing, but could cause problems if added */
		// EventBroker.pageEventQueue[pageId].numberOfPortlets = 0;	/* This was missing, but could cause problems if added */

        if(!this.targetPageId){
            // page still not loaded!
            EventBroker.logMessageInServer(1017, "FrameworkEventBroker.launchPageFrameworkEventCallback");
        }else{
			if(EventBroker.getPageObject(this.targetPageId, null, null, true)){
				if(EventBroker.portletsLoaded(this.targetPageId)){	// NB: portletsLoaded doesn't check if iwidgets are loaded, which is the reason for some of the following code here.  Correcting portletsLoaded would be desirable to clean this up.
					// page already loaded, send event now
        		    delete EventBroker.pageEventQueue[pageId];
					this.launchPageSendEvent();
              	}else {
					//PTE TBSM 1294 
					//Not all the portlets are loaded, so we need to wait until they are then call this.launchPageSendEvent() later
					//This is to ensure that portlets that loaded before this callback get a chance to get their event as well just
					//in case we have early portlet loadings and late ones (isolated portlets)

					var portlets = EventBroker.getPortletsFromPage(pageId);
					//console.log( METHODNAME + "portlets on the target page: " + portlets.length );
					EventBroker.launchPageWaitPortletQueue[pageId] = pageInfoObj;
					EventBroker.launchPageWaitPortletQueue[pageId].waitingPortlets = 0;
            		for(var i = 0; i < portlets.length; i++){
						// EventBroker.pageEventQueue[pageId].numberOfPortlets++;	/* This was missing, but could cause problems if added */
                		// need to check if process handler function is defined.
						//If not ready (nonIWidget without a processHandler or iWidget that hasn't had ready flag set yet)....
                		if( ( portlets[i].element.modelObject.portletData.iwidget != "true" && !EventBroker.isProcessHandlerExists(portlets[i].namespace) ) || ( portlets[i].element.modelObject.portletData.iwidget == "true" && portlets[i].element.modelObject.portletData.readyForEvents != "true" ) ) {
							//console.log( METHODNAME + "portlet " + i + " (" + portlets[i].pii + ") is not loaded, incrementing waitingPortlets." );
							EventBroker.launchPageWaitPortletQueue[portlets[i].pii] = true;
							EventBroker.launchPageWaitPortletQueue[pageId].waitingPortlets++;
                		}
            		}
                    //console.log( METHODNAME + "All portlets checked, " + EventBroker.launchPageWaitPortletQueue[pageId].waitingPortlets + " portlets to wait on." );
                    if( EventBroker.launchPageWaitPortletQueue[pageId].waitingPortlets == 0 ) {
                        //console.log( METHODNAME + "Nothing to wait on, sending event NOW!" );
                        delete EventBroker.pageEventQueue[pageId];
                        delete EventBroker.launchPageWaitPortletQueue[pageId];
                        this.launchPageSendEvent();
                    }
				}
			}
		}
    }

    this.launchPageSendEvent=function(){
        var pageObj = EventBroker.getPageObject(this.targetPageId, null, null,
true);
        if(!pageObj){
            // page still not found
            EventBroker.logMessageInServer(1021, "FrameworkEventBroker.launchPageFrameworkEventCallback");
        }else{
            EventBroker.broadcastToPage(this.targetPageId, this.eventObj, null);
        }
    }
    //
    //handle set title Framerok event
    //
    this.handleSetTitleFrameworkEvent=function(){
    	var currentPage=IscPages.getPageElementById(IscPages.currentPageId);
		if (currentPage.modelObject.getLayoutType() == "Classic") {
		//if it is a Classic page, manuplate the DOM
			if (dojo.byId("titleText."+this.sourcePortletId) != null){
				// the event is from an iWidget
				var titleRoot = dojo.byId("titleText."+this.sourcePortletId);
			} else{
				// the event is from an portlet
				var titleRoot = dojo.byId(this.sourcePortletId+"_title");
			}
			dojo.query("span",titleRoot)[0].innerHTML = this.eventObj.payload.title;
		} else{
			//if it is a freeform page, set the title directly
			var portlet = dijit.byId(this.sourcePortletId);
			portlet.set("portletTitle", this.eventObj.payload.title);
		}	
    }
    //
    // Handles the switchPage framework event
    //
    this.handleSwitchPageFrameworkEvent=function(){
        if(!this.eventObj.NavigationNode){
            EventBroker.logErrorMessage(1014);
        }
        var taskID = this.eventObj.pageInstanceRef;
        var lastVisitedPageStack = EventBroker.getLastVisitedPageStack();
        var pageIdToSwitch = null;
        while(lastVisitedPageStack.length > 0){
            currentId = lastVisitedPageStack.pop();
            if(currentId.indexOf(this.eventObj.NavigationNode) != -1){
                // match the page id in the breadcrumb stack
                pageIdToSwitch = currentId;
                if(!taskID){
                    break;
                }else if(pageIdToSwitch.indexOf(taskID) != -1){
                    // match the taskId, stop the search
                    break;
                }
            }
        }
        if(pageIdToSwitch){
            if(pageIdToSwitch == IscPages.currentPageId){
                // already on the page, send event
                this.switchPageFrameworkEventCallback();
            }else{
                var navInfo = EventBroker.getNavigationInfo(pageIdToSwitch);
                this.targetPageId = pageIdToSwitch;
                var tid = this.eventObj.pageInstanceRef;
                if(!tid){
                    tid = navInfo.taskId;
                }
                DynamicUI.switchPage(this.eventObj.NavigationNode, navInfo.moduleId,tid,this, this.switchPageFrameworkEventCallback);
           }
        }else{
            EventBroker.logErrorMessage(1020);
        }
    }

    this.switchPageFrameworkEventCallback=function(pageId){
        EventBroker.broadcastToPage(this.targetPageId, this.eventObj, null);
    }

    //
    // Handles the launchPortlet framework event
    //
    this.handleLaunchPortletFrameworkEvent=function(){
        var portletId = this.eventObj.portletInstanceRef;
        var portletAppId = this.eventObj.portletApplicationID;
        var portletName = this.eventObj.portletName;
        var pageId = this.eventObj.NavigationNode; 

        if ( !pageId ){
            pageId = IscPages.currentPageId;

            //
            // Temporary fix for this weird bug where the
            // currentPage becomes WelcomePage.
            // Need to switch back to current page before
            // launching the portlet
            if(!this.portletLaunchNoSwitchPage){
                this.portletLaunchNoSwitchPage = "true";
                this.eventObj.switchPage = true;
                this.eventObj.NavigationNode = pageId;
                this.launchPortletAfterPageLaunched = true;
                this.handleLaunchPageFrameworkEvent(false);
                return;
            }
        }else{
            //
            // Launch portlet on another page
            //
            if(IscPages.currentPageId.indexOf(pageId) == -1){
                // launch the page first
                this.eventObj.switchPage = true;
                this.launchPortletAfterPageLaunched = true;
                this.handleLaunchPageFrameworkEvent(false);
                return;
            }
            var taskID = this.eventObj.pageInstanceRef;
            var lastVisitedPageStack = EventBroker.getLastVisitedPageStack();
            var pageIdToSwitch = null;
            while(lastVisitedPageStack.length > 0){
                currentId = lastVisitedPageStack.pop();
                if(currentId.indexOf(pageId) != -1){
                    // match the page id in the breadcrumb stack
                    pageIdToSwitch = currentId;
                    if(!taskID){
                        break;
                    }else if(pageIdToSwitch.indexOf(taskID) != -1){
                        // match the taskId, stop the search
                        break;
                    }
                }
            }
        }

        if(!portletAppId){
            EventBroker.logErrorMessage(1018);
        }
        if(!portletName){
            EventBroker.logErrorMessage(1019);
        }
        if(portletId){
            // send event directly to portlet
            EventBroker.sendEventToPortlet(portletId, this.eventObj);
        }else{
            DynamicUI.launchPortlet( portletName,portletAppId,this,this.launchPortletFrameworkEventCallback, pageId ); 
        }
    }

    this.launchPortletFrameworkEventCallback=function(namespace, pii){
        this.targetPortletId = namespace;
        var pageObj = EventBroker.getPageObject(IscPages.currentPageId);
        if(EventBroker.isProcessHandlerExists(namespace) || pageObj.pageData.stateMaintained == "true"){
            EventBroker.sendEventToPortlet(namespace, this.eventObj);
        }else{
            EventBroker.portletEventQueue[pii] = this.eventObj;
        }
    }

    // 
    // Broadcast this framework event to all the portlets on the specified
    // page id
    //
    this.handleUnknownFrameworkEvent=function(){
        var pageId = this.currentPageId;
        EventBroker.broadcastToPage(pageId, this.eventObj, this.excludePiiBroadcast, false, true, null);
    }

    // starts executing the framework event
    try{
        this.handleFrameworkEvent();
    }catch(error){
        EventBroker.doFinishSendEvent(this.sourcePortletId);
        throw error;
    }
}

// Framework events
FrameworkEventBroker.LaunchPageEvent = "http://ibm.com/isclite#launchPage";
FrameworkEventBroker.SwitchPageEvent = "http://ibm.com/isclite#switchPage";
FrameworkEventBroker.LaunchPortletEvent = "http://ibm.com/isclite#launchPortlet";
FrameworkEventBroker.ClosePageEvent = "http://ibm.com/isclite#closePage";
FrameworkEventBroker.LogoutEvent = "http://ibm.com/isclite#logout";
FrameworkEventBroker.PortletResizeEvent = "http://ibm.com/isclite#portletResize";
FrameworkEventBroker.PageFocusEvent = "http://ibm.com/isclite#pageFocus";
FrameworkEventBroker.SetTitleEvent = "http://ibm.com/isclite#setTitle";
//
// Return a boolean whether it is a framework event
// @param eventName event name to check
// @return a boolean whether it is a framework event
//
FrameworkEventBroker.isFrameworkEvent=function(eventName){
    var frameworkEvent = false;
    if(FrameworkEventBroker.LaunchPageEvent == eventName){
        frameworkEvent = true;
    }else if(FrameworkEventBroker.SwitchPageEvent == eventName){
        frameworkEvent = true;
    }else if(FrameworkEventBroker.LaunchPortletEvent == eventName){
        frameworkEvent = true;
    }else if(FrameworkEventBroker.SetTitleEvent == eventName){
        frameworkEvent = true;
    }
    return frameworkEvent;
}
 



// Transformation class - handles all the transformation operations and calls the
// EventBroker functions to send the event after the transformation is completed.
// @param transformationObj transformation object that contains the info
// @param eventObj the event object that contains the parameters
// @param srcModuleId module ID (specified in ibm-poral-topology.xml)
//                    of the ISC module where source portlet is included 
// @param srcPortletName the name of the portlet that fires the event
// @param srcPortletApp portlet Application( specified in portlet.xml) of the source portlet
// @param targetPageId the target page id. If null, it won't send event after transformation. Mainly use for Javascript transformation.
// @param targetPortletId the target portlet id. If null, it won't send event after transformation. Mainly use for Javascript transformation.
// @param excludePii an array of Pii's to exclude from broadcast. Optional.
//
function Transformation(transformationObj, eventObj, srcModuleId, srcPortletName, srcPortletApp, targetPageId, targetPortletId, excludePii){
    this.transformationObj = transformationObj;
    this.srcEventObj = eventObj;
    this.srcModuleId = srcModuleId;
    this.srcPortletName = srcPortletName;
    this.srcPortletApp = srcPortletApp;
    this.targetPageId = targetPageId;
    this.targetPortletId = targetPortletId;
    this.excludePiiBroadcast = excludePii;
    this.getTransformationHandler = null;
    this.isGetAllTransformations = false;
    this.externalExecuteTransform = false;

	//CR181 we'll use this for caching
	this.actionUrl = null;

    //
    // Perform transformation
    // @return an object that contains the following properties:
    //         errorCode - the error code, if any
    //         targetEventObject - the transformed event object
    //         transformationInProgress - a boolean whether ajax call is used to do transformation
    // 
	this.doTransformation=function() {
		var eventActionUrl = null;
		var returnObject = { "errorCode": 0, "transformationInProgress": false};
		var srcElement = { "srcPortletName": this.srcPortletName,
			"srcModuleId": this.srcModuleId,
			"srcPortletApplication": this.srcPortletApp
		};
		if( this.transformationObj.type == Transformation.TYPE_JAVA ) {
			//Cache based on executable, srcEventObj, srcElement, targetEventName
			eventActionUrl = Transformation.EventActionUrl + "?" +
							 Transformation.EventAction_ExecutableParam + "=" + this.encodeString(this.transformationObj.executable) +
							 "&" + Transformation.EventAction_ActionParam + "=javaTransformation" +
							 "&" + Transformation.EventAction_SrcEventParam + "=" + this.encodeString(/*TIP_DOJO_NS*/dojo.toJson(this.srcEventObj)) +
							 "&" + Transformation.EventAction_SrcElementParam + "=" + this.encodeString(/*TIP_DOJO_NS*/dojo.toJson(srcElement));  
			if( this.transformationObj.targetEventName ) {
				eventActionUrl += "&" + Transformation.EventAction_TargetEventName + "=" + this.encodeString(this.transformationObj.targetEventName);
			}
			eventActionUrl += "&XSS="+top.window.XSS;

		} else if( this.transformationObj.type == Transformation.TYPE_JAVASCRIPT ) {
			// create the js function script
			var evalScript = "var targetEventObject = " + this.transformationObj.executable + "(";
			evalScript += "this.srcEventObj,";
			evalScript += "srcElement,";
			evalScript += "this.transformationObj.targetEventName";

			if( this.transformationObj.uniqueName == Transformation.SimpleStringTransformation ) {
				// Simple string Transformation, add paramMapping
				evalScript += ",this.transformationObj.paramMapping";
			}

			// call the transformation js function 
			eval(evalScript + "" + ")");
			returnObject.targetEventObject = targetEventObject;
		} else if( this.transformationObj.type == Transformation.TYPE_URL ) {
			//Cache based on executable, srcEventObj, srcElement, targetEventName
			eventActionUrl = Transformation.EventActionUrl + "?";
			eventActionUrl += Transformation.EventAction_ExecutableParam + "=" + encodeURIComponent(this.transformationObj.executable) +
							  "&" + Transformation.EventAction_ActionParam + "=urlTransformation" +
							  "&" + Transformation.EventAction_SrcEventParam +
							  "=" + encodeURIComponent(/*TIP_DOJO_NS*/dojo.toJson(this.srcEventObj)) +
							  "&" + Transformation.EventAction_SrcElementParam +
							  "=" + encodeURIComponent(/*TIP_DOJO_NS*/dojo.toJson(srcElement)); 
			if( this.transformationObj.targetEventName ) {
				eventActionUrl += "&" + Transformation.EventAction_TargetEventName  + "=" + encodeURIComponent(this.transformationObj.targetEventName);
			}
			eventActionUrl += "&XSS="+top.window.XSS;

		} else {
			// unknown type
			EventBroker.logErrorMessage(1008);
		}

		if( eventActionUrl ) {

			//CR181 begin
			// get the transformed event from cache or create a cache entry
			// Cache based on event ID + eventActionUrl (which includes executable, srcEventObj, srcElement, targetEventName)
			this.actionUrl = eventActionUrl;
			var transformedEventID = this.srcEventObj[EventBroker.Internal_TIP_Event_Identifier_Key] + this.actionUrl;
			var transformedEventCacheEntry = EventBroker.transformedEventCache[transformedEventID];
		
			// Get cache entry, creating if necessary
			if (typeof transformedEventCacheEntry == "undefined" || transformedEventCacheEntry == null) {
				if (EventBroker.transformedEventCacheQueue.length >= EventBroker.transformedEventCacheQueueSize) {
		      var itemToRemove = EventBroker.transformedEventCacheQueue.shift();
		      var CacheEntryToRemove = EventBroker.transformedEventCache[itemToRemove];
		      
		      //delete the waiting handlers and print messages, not to call them to avoid looping.
		      CacheEntryToRemove.transformingEvent = false;
          var receiverHandler;
          while (receiverHandler = CacheEntryToRemove.eventHandlerQueue.shift()) {
		        console && console.log && console.log("removing handler for expired cache entry");
		      }
		      CacheEntryToRemove = null;
		      
		      //try{
		        delete EventBroker.transformedEventCache[itemToRemove]; //both FF and IE can run this line well, so I commented the try-catch block out
		      //} catch(a) {
		      	//EventBroker.transformedEventCache[itemToRemove] = null;
		      //}
		      console && console.log && console.log("removed one cache entry from EventBroker.transformedEventCache");
		    }
				
				//create cache entry and push the ID in sorting queue.
			  EventBroker.transformedEventCache[transformedEventID] = transformedEventCacheEntry = {'transformingEvent': false, 'eventHandlerQueue': new Array()};
		    EventBroker.transformedEventCacheQueue.push(transformedEventID);
		  }

			// If there was a cached transformed event, pass it to the callback function
			if( typeof transformedEventCacheEntry.cachedTransformedEventString != 'undefined' && transformedEventCacheEntry.cachedTransformedEventString != null ) { //CR181, "||" -> "&&"
				console && console.log && console.log("Transformed event retrieved from cache");
				returnObject.transformationInProgress = true;
				setTimeout(dojo.hitch(this, this.transformationServiceCallback, transformedEventCacheEntry.cachedTransformedEventString, {xhr:{status:200}}),0); //CR181, simulate AJAX call by settimeout.	
			}
			//CR181 end
			// If there was no cached transformed event, get it with ajax and pass it to the callback function
			else {
				//if the previous transformation is not finished, push the handler to queue
		    if (transformedEventCacheEntry.transformingEvent) {
		      transformedEventCacheEntry.eventHandlerQueue.push(dojo.hitch(this, this.doTransformation));
		      returnObject.transformationInProgress = true;
		      return(returnObject);
		    } else {
				  transformedEventCacheEntry.transformingEvent = true;
				  var handler = this.transformationServiceCallback;
				  var timeoutHandler = this.handleTimeout;
				  /*TIP_DOJO_NS*/dojo.xhrGet( {
											url:        eventActionUrl,
											load:		/*TIP_DOJO_NS*/dojo.hitch(this, handler), 
											handleAs:   "text",
											timeoutSeconds: 5,
											timeout: /*TIP_DOJO_NS*/dojo.hitch(this, timeoutHandler)
											} );
				  returnObject.transformationInProgress = true;
			  }
		  }
		}

		return(returnObject);
	}

    this.encodeString=function(str){
      str = escape(encodeURIComponent(str));
      return str;
    }

    //
    // Callback function for transformation ajax call to do transformation
    //
    this.transformationServiceCallback=function(data, ioArgs){
        var type = ioArgs.xhr.status;
        
      //CR181 begin
      //cache the transformed event
			var transformedEventID = this.srcEventObj[EventBroker.Internal_TIP_Event_Identifier_Key] + this.actionUrl;
			var transformedEventCacheEntry = EventBroker.transformedEventCache[transformedEventID];

      if(type == "200"){
		    if(typeof transformedEventCacheEntry != "undefined" && transformedEventCacheEntry != null && typeof transformedEventCacheEntry.cachedTransformedEventString == "undefined" ) {
		      //cache the returned data
		      transformedEventCacheEntry.cachedTransformedEventString = data;
		      
		      console && console.log && console.log("Transformed event retrieved from server.");
		    }
		  //CR181 end)

            if(data == ""){
                // transformation returned nothing, log error
                EventBroker.logMessageInServer(1016, "transformationServiceCallback");
                EventBroker.logErrorMessage(1016);
            }
            var targetEventObject = null;
            try{
                eval("targetEventObject = " + data);
            }catch(error){
                EventBroker.logMessageInServer(1022, "transformationServiceCallback", [error, data]);
                EventBroker.logErrorMessage(1022, [error, data]);
            }
            if(this.externalExecuteTransform){
                // call callback function from EventBroker.executeTransform
               this.transformInfo.handler.apply(this, [targetEventObject]);
            }
            if(this.targetPageId){
                EventBroker.broadcastToPage(this.targetPageId, targetEventObject, this.excludePiiBroadcast);
            }else if(this.targetPortletId){
                var porletObj = EventBroker.getPortletObjectByNamespace(this.targetPortletId);
                if (porletObj.portletData.iwidget == "true") {//247301, send the event object to iWidget.
                    if (iWBridge) iWBridge.processIWidgetWire(iWidgetUtils.piiToWidgetId(porletObj.portletData.oid), targetEventObject.name, null, targetEventObject);
                } else {
                    EventBroker.sendEventToPortlet(this.targetPortletId, targetEventObject);
                }
            }
            
            //CR181 begin
            //the transformed event is returned and cached, call other queued handlers.
            if(typeof transformedEventCacheEntry != "undefined" && transformedEventCacheEntry != null) {
		            transformedEventCacheEntry.transformingEvent= false;
		    
                try {
                    var receiverHandler;
                    while (receiverHandler = transformedEventCacheEntry.eventHandlerQueue.shift()) {
		                    if (typeof receiverHandler == "function") {
		                        receiverHandler();
		                    }
		                }
		            } catch(ex) {
		                console && console.log && console.log("failed to execute transformed event handlers in queue. " + ex.message);
		            }
		        }
		        //CR181 end
        }else{
            // log error
            EventBroker.logMessageInServer(1009, "transformationServiceCallback");
            EventBroker.logErrorMessage(1009);
            
            //CR181 begin
            //error happens, removing cache entry
            console && console.log && console.log("Transformed event cache: incorrect resonse from server. removing the cache entry.");
            while (CacheEntryToRemove.eventHandlerQueue.pop()) {
		        }
		        delete EventBroker.transformedEventCache[transformedEventID];
		        //CR181 end
        }
    }

    //
    // Clean up transformation and log error
    //
    this.handleTimeout=function(data, ioArgs){
        // log error
        EventBroker.logMessageInServer(1010, "handleTimeout");
        EventBroker.logErrorMessage(1010);
        
        //CR181 begin
        //timeout happens, clear the waiting handlers in queue
        console && console.log && console.log("Transformed event cache: request timeout. removing the cache entry.");
        var transformedEventID = this.srcEventObj[EventBroker.Internal_TIP_Event_Identifier_Key] + this.actionUrl;
        if (typeof EventBroker.transformedEventCache[transformedEventID] != "undefined" && EventBroker.transformedEventCache[transformedEventID] != null) {
          while (CacheEntryToRemove.eventHandlerQueue.pop()) {
		      }
		      
		      delete EventBroker.transformedEventCache[transformedEventID];
        }
        
        var transformCacheId = this.transformStringCacheKey1 + "   " + this.transformStringCacheKey2;
        console && console.log && console.log("Transform cache: request timeout. Removing cache entry.");
        while(EventBroker.transformsQueue.pop()) {
        }
        delete EventBroker.transformStringCache[transformCacheId];
        //CR181 end
    }

    //
    // Callback function for executing transform callback
    // 
    this.executeTransformCallback=function(transformData){
        this.transformationObj = transformData;
        this.srcEventObj = this.transformInfo.eventObj;
        var portletObj = EventBroker.getPortletObjectByNamespace(this.transformInfo.srcPortletNamespace);
        this.srcModuleId = (portletObj == null) ? "" : portletObj.page.pageData.moduleRef;
        this.srcPortletName = (portletObj == null) ? "" : portletObj.portletData.portletName;
        this.srcPortletApp = (portletObj == null) ? "" : portletObj.portletData.moduleRef;
        this.externalExecuteTransform = true;

        // call transform
        this.doTransformation();
    }

    //
    // Callback function for transformation ajax call to get info
    //
    this.getTransformationInfoCallback=function(data, ioArgs){
        var type = ioArgs.xhr.status;
        
			//CR181
			// Store the transformation string in the cache
			var transformCacheId = this.transformStringCacheKey1 + "   " + this.transformStringCacheKey2
			var transformCacheEntry = EventBroker.transformStringCache[transformCacheId];
			
        if(type == "200"){
			      //check if the transform string is already cached. if not, then cache it.
			      if (typeof transformCacheEntry != "undefined" && transformCacheEntry != null && typeof transformCacheEntry.transformationString == "undefined") {
			          transformCacheEntry.transformationString = data;
			          console && console.log && console.log("Transformation retrieved from server.");
			      }

            var transformationObj = null;
            try{
                eval("transformationObj = " + data);
            }catch(error){
                EventBroker.logMessageInServer(1023, "transformationInfoCallback", [error, data]);
                EventBroker.logErrorMessage(1023, [error, data]);
            }
            if(this.isGetAllTransformations){
                // this is get all transformations, return the array of objects
                transformationObj = transformationObj.transformations;
            }
            if(typeof this.getTransformationHandler=="function"){
               this.getTransformationHandler(transformationObj);
            }else{
               eval(this.getTransformationHandler + "(transformationObj)");
            }
            
            //CR181 begin
            //the transform string is returned and cached, call queued handlers.
            if (typeof transformCacheEntry != "undefined" && transformCacheEntry != null) {
                EventBroker.transformStringCache[transformCacheId].gettingTransform = false;

                while(transformParams = EventBroker.transformsQueue.shift()) {
                    if (transformParams)
                        EventBroker.getTransformation(transformParams.transformationUniqueName, transformParams.transformationLocationName, transformParams.handler);
                }
            }
            //CR181 end
        }else{
            //log error
            EventBroker.logMessageInServer(1011, "getTransformationInfoCallback");
            EventBroker.logErrorMessage(1011);
            
            //if error happens, clear the cache entry
            console && console.log && console.log("Transform cache: Request failed. Removing cache entry.");
            while(EventBroker.transformsQueue.pop()) {
            }
            delete EventBroker.transformStringCache[transformCacheId];
        }
    }

}

// Transformation types
Transformation.TYPE_JAVA = 0;
Transformation.TYPE_JAVASCRIPT = 1;
Transformation.TYPE_URL = 2;

Transformation.SimpleStringTransformation = "com.ibm.isclite.samples.transformation.ISCSimpleStringTransformation";

Transformation.EventActionUrl = contextRoot + "/eventAction.do" ;
Transformation.EventAction_ActionParam = "action";
Transformation.EventAction_ExecutableParam = "executable";
Transformation.EventAction_SrcElementParam = "srcElement";
Transformation.EventAction_SrcEventParam = "srcEvent";
Transformation.EventAction_TargetEventName = "targetEventName";
Transformation.EventAction_MsgParam = "msg";
Transformation.EventAction_MethodNameParam = "msg";
